############################################################################
#                                                                          #
#  Copyright (c) 2001, 2025 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXClusterTools::generateClusterGUID{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x75");(my (@options)=());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmdErr,$cmdOut,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x0334+ 2820-0x0e38))){Logger::warning (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20\x47\x55\x49\x44\x2e"
);return ((""));}chomp ($cmdOut);return ($cmdOut);}sub 
NXClusterTools::generateClusterKeys{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);(my $priv=
NXPaths::getClusterRSAPrivateKey ());(my $pub=NXPaths::getClusterRSAPublicKey ()
);push (@command,"\x2d\x6b",$priv);push (@command,"\x2d\x70",$pub);push (
@command,"\x2d\x74","\x72\x73\x61");(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmd_err,$cmd_out,
$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x0bc0+ 4883-0x1ed2))))
{Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20\x27"
.$priv)."\x27\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x1600+ 4101-0x2604)))){Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::generateClusterHostCerts{package 
NXClusterTools;no warnings;(my (@command)=());push (@command,
$GLOBAL::COMMAND_NXKEYGEN);(my $priv=NXPaths::getClusterHostPrivateCert ());(my $pub
=NXPaths::getClusterHostPublicCert ());push (@command,"\x2d\x6b",$priv);push (
@command,"\x2d\x63",$pub);(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x1beb+ 1074-0x201c))))
{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x06bb+ 6483-0x200d)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::getIpv6DeleteCommand{package 
NXClusterTools;no warnings;(my $interface=shift (@_));(my $ip=shift (@_));(my $mask
=shift (@_));(my (@command)=());sub BEGIN{require NXTools;do{
"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};}(my $tool=NXTools::getUnixCommandPath (
"\x69\x70"));if ((not (Common::NXFile::isExists ($tool)))){($tool=
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$tool);push (@command,$interface);push (@command,"\x69\x6e\x65\x74\x36",
"\x64\x65\x6c");push (@command,(($ip."\x2f").$mask));}else{push (@command,$tool,
"\x2d\x36");push (@command,"\x61\x64\x64\x72\x65\x73\x73",
"\x64\x65\x6c\x65\x74\x65");push (@command,(($ip."\x2f").$mask));push (@command,
"\x64\x65\x76",$interface);}return (@command);}sub 
NXClusterTools::getIpv4DeleteCommand{package NXClusterTools;no warnings;(my $interface
=shift (@_));(my $ip=shift (@_));(my $mask=shift (@_));(my (@command)=());if ((
not (($interface=~ /:/ )))){Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x45\x78\x70\x65\x63\x74\x65\x64\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x61\x6c\x69\x61\x73\x20\x6e\x61\x6d\x65\x20\x27"
.$interface)."\x27\x2e\x20\x49\x67\x6e\x6f\x72\x69\x6e\x67\x2e"));return (());
sub BEGIN{require NXTools;do{"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};};}(my $tool
=NXTools::getUnixCommandPath ("\x69\x70"));if ((not (Common::NXFile::isExists (
$tool)))){($tool=NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"
));push (@command,$tool);push (@command,$interface);push (@command,
"\x64\x6f\x77\x6e");}else{push (@command,$tool);push (@command,
"\x61\x64\x64\x72\x65\x73\x73","\x64\x65\x6c\x65\x74\x65");push (@command,(($ip.
"\x2f").$mask));($interface=~ /(.*):(\d+)/ );(my $device=$1);push (@command,
"\x64\x65\x76",$device);push (@command,"\x6c\x61\x62\x65\x6c",$interface);}
return (@command);}sub NXClusterTools::isIpv6{package NXClusterTools;no warnings
;(my $ip=shift (@_));if (($ip=~ /.*:.*:.*/ )){return ((0x0b15+ 3217-0x17a5));}}
sub NXClusterTools::cleanInterface{package NXClusterTools;no warnings;
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x43\x6c\x65\x61\x6e\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2e"
);(my ($interface,$ip,$mask)=__readInterfaceFromFile ());if (($interface eq ("")
)){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"
);return ((0x035c+ 759-0x0653));}if (($GLOBAL::ScriptClusterClearIP ne (""))){
main::nxrequire ("\x4e\x58\x53\x63\x72\x69\x70\x74\x73");(my ($error,$output,
$exitValue)=NXScripts::runScript (
"\x73\x63\x72\x69\x70\x74\x5f\x63\x6c\x75\x73\x74\x65\x72\x5f\x63\x6c\x65\x61\x72\x5f\x69\x70"
,$interface,$ip,$mask));if (($exitValue!=(0x1ce3+ 1536-0x22e3))){Logger::error (
((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x27".
$GLOBAL::ScriptClusterClearIP).
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x49\x50\x20\x27"
).$ip)."\x27\x2e"));Logger::error (((((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27".$exitValue)."\x27\x20\x27").$error).
"\x27\x20\x27").$output)."\x27\x2e"));}else{Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x27".
$GLOBAL::ScriptClusterClearIP).
"\x27\x20\x68\x61\x73\x20\x63\x6c\x65\x61\x6e\x65\x64\x20\x75\x70\x20\x49\x50\x20\x27"
).$ip)."\x27\x2e"));}removeInterfaceFile ();return ($exitValue);}Logger::debug (
((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x43\x6c\x65\x61\x6e\x20\x75\x70\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x20\x68\x6f\x73\x74\x20\x27").$ip).
"\x27\x20\x6d\x61\x73\x6b\x20\x27").$mask)."\x27\x2e"));(my (@command)=());if (
isIpv6 ($ip)){(@command=getIpv6DeleteCommand ($interface,$ip,$mask));}else{(
@command=getIpv4DeleteCommand ($interface,$ip,$mask));}if ((scalar (@command)==
(0x0576+ 6806-0x200c))){return ((0x187f+  31-0x189e));}(my (@options)=());(my (
$cmdOut,$cmdErr,$exitValue)=main::nxRunCommand ((\@command),(\@options)));if ((
$exitValue!=(0x0a5f+ 1645-0x10cc))){Logger::error (((((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x64\x65\x6c\x65\x74\x65\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$exitValue)
."\x27\x2e\x20\x27").$cmdOut)."\x27\x20\x27").$cmdErr)."\x27\x2e"));}else{
Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x20\x61\x6c\x69\x61\x73\x20\x27").$ip).
"\x27\x20\x64\x65\x6c\x65\x74\x65\x64\x2e"));}removeInterfaceFile ();return (
$exitValue);}sub NXClusterTools::saveInterfaceToFile{package NXClusterTools;no 
warnings;(my $interface=shift (@_));(my $clusterHost=shift (@_));(my $ClusterMask
=shift (@_));(my $filename=NXPaths::getClusterInterfaceFile ());(my $fileExisted
=(0x0889+ 5422-0x1db7));if (Common::NXFile::fileExists ($filename)){(
$fileExisted=(0x0bf0+ 5212-0x204b));}(my $FH=main::nxopen ($filename,(
$NXBits::O_RDWR+$NXBits::O_CREAT),(($NXBits::OthersRead+$NXBits::UserReadWrite)+
$NXBits::GroupRead)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorstring).
"\x2e"));return ((0x0ac4+ 6381-0x23b0));}if ((main::nxwrite ($FH,(((($interface.
"\x0a").$clusterHost)."\x0a").$ClusterMask))==(-(0x0158+ 5858-0x1839)))){
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$filename)."\x27\x2e"));main::nxclose ($FH);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($filename);}return ((0x1e54+ 767-0x2152));}
main::nxclose ($FH);if ((not ($fileExisted))){changeFileOwnershipToNxIfRoot (
$filename);}return ((0x0695+ 7884-0x2561));}sub 
NXClusterTools::removeInterfaceFile{package NXClusterTools;no warnings;(my $filename
=NXPaths::getClusterInterfaceFile ());if (Common::NXFile::isExists ($filename)){
Common::NXFile::removeFile ($filename);}}sub 
NXClusterTools::doesInterfaceFileExist{package NXClusterTools;no warnings;(my $filename
=NXPaths::getClusterInterfaceFile ());if (Common::NXFile::fileExists ($filename)
){return ((0x0826+ 6673-0x2236));}return ((0x0f30+ 4084-0x1f24));}sub 
NXClusterTools::__readInterfaceFromFile{package NXClusterTools;no warnings;if ((
not (doesInterfaceFileExist ()))){return ((""),(""),(""));}(my $filename=
NXPaths::getClusterInterfaceFile ());(my $FH=main::nxopen ($filename,
$NXBits::O_RDONLY,(0x1303+ 3556-0x20e7)));if ((not (defined ($FH)))){(my $errorNumber
=libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$filename)."\x27\x20\x66\x6f\x72\x20\x72\x65\x61\x64\x69\x6e\x67\x2e"));
Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber).
"\x2c\x20").$errorstring)."\x2e"));return ((""),(""),(""));}my ($interface);my (
$clusterHost);my ($clusterMask);main::nxreadLine ($FH,(\$interface));
main::nxreadLine ($FH,(\$clusterHost));main::nxreadLine ($FH,(\$clusterMask));
main::nxclose ($FH);chomp ($interface);chomp ($clusterHost);chomp ($clusterMask)
;Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x61\x64\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x20\x49\x50\x20\x27").$clusterHost).
"\x27\x20\x6e\x65\x74\x6d\x61\x73\x6b\x20\x27").$clusterMask)."\x27\x2e"));
return ($interface,$clusterHost,$clusterMask);}sub NXClusterTools::getInterfaces
{package NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x47\x65\x74\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x2e"
);(my (%interfaces)=());Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=main::urldecode (libnxh::NXGetNetworkInterfaces ()));Logger::debug
 (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (@lines)=split ( /\n/ ,$return,(0x0e65+ 280-0x0f7d)))
;foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET[6]{0,1}\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(.*)\s+(.*)\s+/ )
){(my $iface=$1);(my $address=$4);(my $mask=$5);Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$iface)."\x27\x20\x49\x50\x20\x27").$address).
"\x27\x20\x6d\x61\x73\x6b\x20\x27").$mask)."\x27\x2e"));($interfaces{$iface}={
"\x69\x70",$address,"\x6d\x61\x73\x6b",$mask});}}return (%interfaces);}sub 
NXClusterTools::getInterfacesData{package NXClusterTools;no warnings;(my $data=
shift (@_));(my (%ips)=getIps ());foreach my $name (keys (%ips)){(my $ip=
main::urlencode ($name));(my $iface=main::urlencode ($ips{$name}{
"\x69\x6e\x74\x65\x72\x66\x61\x63\x65"}));(my $mask=main::urlencode ($ips{$name}
{"\x6d\x61\x73\x6b"}));($data.=(((((("\x69\x70\x3d".$ip).
"\x2c\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x3d").$iface).
"\x2c\x6e\x65\x74\x6d\x61\x73\x6b\x3d").$mask)."\x0a"));}return ($data);}sub 
NXClusterTools::getIps{package NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x47\x65\x74\x20\x49\x50\x73\x2e"
);Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (%ips)=());(my (@lines)=split ( /\n/ ,$return,
(0x15f0+ 3732-0x2484)));foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET[6]{0,1}\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(.*)\s+(.*)\s+/ )
){(my $iface=$1);(my $address=$4);(my $mask=$5);Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x49\x50\x20\x27"
.$address)."\x27\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27").$iface).
"\x27\x20\x6d\x61\x73\x6b\x20\x27").$mask)."\x27\x2e"));($ips{$address}={
"\x69\x6e\x74\x65\x72\x66\x61\x63\x65",$iface,"\x6d\x61\x73\x6b",$mask});}}
return (%ips);}sub NXClusterTools::doesIpExist{package NXClusterTools;no 
warnings;(my $ip=shift (@_));if ((getInterfaceForIp ($ip)ne (""))){return (
(0x1745+ 2450-0x20d6));}return ((0x01e5+ 4613-0x13ea));}sub 
NXClusterTools::removeInterface{package NXClusterTools;no warnings;(my $ip=shift
 (@_));(my (@address)=split ( /%/ ,$ip,(0x0c44+ 414-0x0de2)));return (@address[
(0x0d7b+ 690-0x102d)]);}sub NXClusterTools::getInterfaceForIp{package 
NXClusterTools;no warnings;(my $ip=shift (@_));(my $data=shift (@_));my (%ips);
if (($data ne (""))){Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x72\x65\x6d\x6f\x74\x65\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x66\x6f\x72\x20\x69\x70\x20\x27"
.$ip)."\x27\x20\x69\x6e\x20\x64\x61\x74\x61\x20\x27").$data)."\x27\x2e"));((%ips
)=%$data);}else{Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x6c\x6f\x63\x61\x6c\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x66\x6f\x72\x20\x69\x70\x20\x27"
.$ip)."\x27\x2e"));((%ips)=getIps ());}(my $iface=$ips{$ip}{
"\x69\x6e\x74\x65\x72\x66\x61\x63\x65"});if (($iface ne (""))){Logger::debug (((
((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x6f\x75\x6e\x64\x20\x49\x50\x20\x27"
.$ip)."\x27\x20\x6f\x6e\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27").$iface
)."\x27\x2e"));return ($iface);}Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x2e"
);return ((""));}sub NXClusterTools::getNetmaskForIp{package NXClusterTools;no 
warnings;(my $ip=shift (@_));(my $data=shift (@_));my (%ips);if (($data ne (""))
){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x72\x65\x6d\x6f\x74\x65\x20\x6e\x65\x74\x6d\x61\x73\x6b\x20\x66\x6f\x72\x20\x49\x50\x20\x27"
.$ip)."\x27\x2e"));((%ips)=%$data);}else{Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x6c\x6f\x63\x61\x6c\x20\x6e\x65\x74\x6d\x61\x73\x6b\x20\x66\x6f\x72\x20\x49\x50\x20\x27"
.$ip)."\x27\x2e"));((%ips)=getIps ());}foreach my $name (keys (%ips)){if (($name
 eq $ip)){(my $netmask=$ips{$name}{"\x6d\x61\x73\x6b"});Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x6f\x75\x6e\x64\x20\x6e\x65\x74\x6d\x61\x73\x6b\x20\x27"
.$netmask)."\x27\x20\x66\x6f\x72\x20\x49\x50\x20\x27").$name)."\x27\x2e"));
return ($netmask);}}Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x4e\x65\x74\x6d\x61\x73\x6b\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x2e"
);return ((""));}sub NXClusterTools::doesInterfaceExist{package NXClusterTools;
no warnings;(my $iface=shift (@_));(my $data=shift (@_));my (%ips);if (($data ne
 (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x72\x65\x6d\x6f\x74\x65\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x66\x6f\x72\x20\x27"
.$iface)."\x27\x2e"));((%ips)=%$data);}else{Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x6c\x6f\x63\x61\x6c\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x66\x6f\x72\x20\x27"
.$iface)."\x27\x2e"));((%ips)=getIps ());}foreach my $name (keys (%ips)){if ((
$ips{$name}{"\x69\x6e\x74\x65\x72\x66\x61\x63\x65"}eq $iface)){Logger::debug (((
((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x6f\x75\x6e\x64\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$ips{$name}{"\x69\x6e\x74\x65\x72\x66\x61\x63\x65"}).
"\x27\x20\x66\x6f\x72\x20\x49\x50\x20\x27").$name)."\x27\x2e"));return (
(0x171c+ 2011-0x1ef6));}}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$iface)."\x27\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x2e"));return (
(0x0407+ 2127-0x0c56));}sub NXClusterTools::getClusterPublicKey{package 
NXClusterTools;no warnings;(my $file=NXPaths::getClusterRSAPublicKey ());if ((
not (Common::NXFile::fileExists ($file)))){generateClusterKeys ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x70\x75\x6c\x69\x63\x20\x6b\x65\x79\x20\x66\x72\x6f\x6d\x20\x70\x61\x74\x68\x20\x27"
.$file)."\x27"));Logger::error ($message);die ($message);}return ($content);}sub
 NXClusterTools::__setDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));(my $content=shift (@_));if (($content ne (""))){NXRedis::sendToDb 
(((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x65\x74\x6e\x78\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x2c\x76\x61\x6c\x75\x65\x3d").main::urlencode ($content))."\x0a"))
;}}sub NXClusterTools::getNodesDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x73");(my $base=
NXNodes::getDatabaseInString ());return (main::urlencode ($base));}sub 
NXClusterTools::getClusterDB{package NXClusterTools;no warnings;(my $base=
getDatabaseInString ());return (main::urlencode ($base));}sub 
NXClusterTools::setClusterDB{package NXClusterTools;no warnings;(my $base=shift 
(@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}cleanDb ();return (setDatabaseByString ($base));}sub 
NXClusterTools::getProfilesDB{package NXClusterTools;no warnings;main::nxrequire
 ("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");(my $base=
NXProfilesDB::getDatabaseInString ());return (main::urlencode ($base));}sub 
NXClusterTools::getProfileServersDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");(my $base=
NXProfilesDB::getProfilesServerSetInString ());return (main::urlencode ($base));
}sub NXClusterTools::getProfileGroupsDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");(my $base=
NXProfilesDB::getProfilesGroupSetInString ());return (main::urlencode ($base));}
sub NXClusterTools::getUsersDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");(my $base
=NXUsersManager::getDatabaseInString ());return (main::urlencode ($base));}sub 
NXClusterTools::getAdministratorsDB{package NXClusterTools;no warnings;
main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);(my $base=NXAdministratorsManager::getDatabaseInString ());return (
main::urlencode ($base));}sub NXClusterTools::getGroupsDB{package NXClusterTools
;no warnings;main::nxrequire ("\x4e\x58\x47\x72\x6f\x75\x70\x73");(my $base=
NXGroups::getDatabaseInString ());return (main::urlencode ($base));}sub 
NXClusterTools::getNXCertsDB{package NXClusterTools;no warnings;main::nxrequire 
("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");(my $base=NXServers::getNXCertsInString
 ());return (main::urlencode ($base));}sub NXClusterTools::getSSHCertsDB{package
 NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");(my $base=NXServers::getSSHCertsInString
 ());return (main::urlencode ($base));}sub NXClusterTools::getNetworkDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x52\x65\x64\x69\x73");(my $base=
NXNetworkRedis::getDatabaseInString ());return (main::urlencode ($base));}sub 
NXClusterTools::getServerDSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPublicKey ());if ((not (Common::NXFile::fileExists ($file)
))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerDSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPrivateKey ());if ((not (Common::NXFile::fileExists ($file
)))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPublicKey ());if ((not (Common::NXFile::fileExists ($file)
))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPrivateKey ());if ((not (Common::NXFile::fileExists ($file
)))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getPlayerCerts{package NXClusterTools;no warnings;(my $file=
NXPaths::getUserNXKnownCerts ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::getHostPrivateCert{package 
NXClusterTools;no warnings;(my $file=NXPaths::getHostPrivateCert ());if ((not (
Common::NXFile::fileExists ($file)))){return ((""));}return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::getHostPublicCert{
package NXClusterTools;no warnings;(my $file=NXPaths::getHostPublicCert ());if (
(not (Common::NXFile::fileExists ($file)))){return ((""));}return (
Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getClusterMasterCertPub{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHostPublicCert ());if ((not (Common::NXFile::fileExists (
$file)))){generateClusterHostCerts ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPriv{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHostPrivateCert ());if ((not (Common::NXFile::fileExists (
$file)))){generateClusterHostCerts ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getHttpHostPrivateCert{package NXClusterTools;no warnings;
Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x47\x65\x74\x20\x48\x54\x54\x50\x20\x68\x6f\x73\x74\x20\x70\x72\x69\x76\x61\x74\x65\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e"
);(my $user=Common::NXCore::getEffectiveUsername ());if (($user ne 
"\x72\x6f\x6f\x74")){return (getHttpHostPrivateCertContent ());}(my $file=
NXPaths::getHttpHostPrivateCert ());if ((not (Common::NXFile::fileExists ($file)
))){return ((""));}(my $content=Common::NXFile::getFileContent ($file));if ((
$content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getHttpHostPublicCert{package NXClusterTools;no warnings;(my $file
=NXPaths::getHttpHostPublicCert ());if ((not (Common::NXFile::fileExists ($file)
))){return ((""));}(my $content=Common::NXFile::getFileContent ($file));if ((
$content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterHttpMasterCertPub{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHttpHostPublicCert ());(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;
return (__getSSHHostKeyPrivate ("\x44\x53\x41"));}sub 
NXClusterTools::getSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPublic ());return (Common::NXFile::getFileContent (
$file));}sub NXClusterTools::getSSHHostKeyRSAPrivate{package NXClusterTools;no 
warnings;return (__getSSHHostKeyPrivate ("\x52\x53\x41"));}sub 
NXClusterTools::getSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyRSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyECDSAPrivate{
package NXClusterTools;no warnings;return (__getSSHHostKeyPrivate (
"\x45\x43\x44\x53\x41"));}sub NXClusterTools::getSSHHostKeyECDSAPublic{package 
NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyECDSAPublic ());
return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getSSHHostKeyED25519Private{package NXClusterTools;no warnings;
return (__getSSHHostKeyPrivate ("\x45\x44\x32\x35\x35\x31\x39"));}sub 
NXClusterTools::getSSHHostKeyED25519Public{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyED25519Public ());return (Common::NXFile::getFileContent 
($file));}sub NXClusterTools::getUserKnownHostsSSH{package NXClusterTools;no 
warnings;return (Common::NXFile::getFileContent (NXPaths::getUserKnownHostsSSH 
()));}sub NXClusterTools::__unsync{package NXClusterTools;no warnings;(my $file=
shift (@_));(my $owner=shift (@_));(my $emptyFile=($file.
"\x2e\x65\x6d\x70\x74\x79"));if (Common::NXFile::fileExists ($emptyFile)){
__remove ($emptyFile);__remove ($file);return ((""),(""));}(my $fileBackup=(
$file."\x2e\x62\x61\x63\x6b\x75\x70"));if (Common::NXFile::fileExists (
$fileBackup)){Logger::debug ((((("\x52\x65\x6e\x61\x6d\x65\x20\x27".$fileBackup)
."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e"));unless (rename ($fileBackup,
$file)){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e\x20").$!));return (
(0x0e40+ 3677-0x1c9c));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x11a7+ 3086-0x1db5));}sub 
NXClusterTools::__unsyncDatabases{package NXClusterTools;no warnings;
Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x64\x65\x73\x79\x6e\x63\x68\x72\x6f\x6e\x69\x7a\x65\x20\x64\x61\x74\x61\x62\x61\x73\x65\x73\x2e"
);if (__isDatabaseBackupExist ("\x6e\x6f\x64\x65\x73")){main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");NXNodes::cleanDb ();NXNodes::setDatabaseByString
 (__getDatabaseBackup ("\x6e\x6f\x64\x65\x73"));}if (__isDatabaseBackupExist (
"\x70\x72\x6f\x66\x69\x6c\x65\x73")){main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");NXProfilesDB::cleanDb ();
NXProfilesDB::setDatabaseByString (__getDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73"));}if (__isDatabaseBackupExist (
"\x75\x73\x65\x72\x73")){main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");
NXUsersManager::cleanDb ();NXUsersManager::setDatabaseByString (
__getDatabaseBackup ("\x75\x73\x65\x72\x73"));}if (__isDatabaseBackupExist (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73")){main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);NXAdministratorsManager::cleanDb ();
NXAdministratorsManager::setDatabaseByString (__getDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x4e\x58")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setNXCertsByString (
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x53\x53\x48")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setSSHCertsByString (
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48"));}if (
__isDatabaseBackupExist ("\x67\x72\x6f\x75\x70\x73")){main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");NXGroups::cleanDb ();
NXGroups::setDatabaseByString (__getDatabaseBackup ("\x67\x72\x6f\x75\x70\x73"))
;}}sub NXClusterTools::__isDatabaseBackupExist{package NXClusterTools;no 
warnings;(my $database=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x69\x73\x74\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (NXRedis::get ());}sub 
NXClusterTools::__getDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (main::urldecode (NXRedis::get ()));}sub 
NXClusterTools::__remove{package NXClusterTools;no warnings;(my $file=shift (@_)
);if (Common::NXFile::fileExists ($file)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x5b".$file)."\x5d"));if ((not (unlink (
$file)))){Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".
$file)."\x20").$!));}}}sub NXClusterTools::unsynchronize{package NXClusterTools;
no warnings;(my $host=shift (@_));if (Server::isDaemonProcess ()){if (
NXRedis::isReplicaRunning ()){NXRedis::startMasterForCluster ();}}else{
main::nxrequire (
"\x4e\x58\x43\x6c\x69\x65\x6e\x74\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73"
);NXClientSystemDaemons::requestDatabaseReplication ();NXRedis::closeDb ();}
__unsync (NXPaths::getUserNXKnownCerts ());__unsync (
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));__unsync (
NXPaths::getNodePublicKeys ());__unsync (NXPaths::getUserKnownHostsSSH ());
__remove (NXPaths::getClusterHostPublicCert ());__remove (
NXPaths::getClusterHostPrivateCert ());if (($host ne "\x6c\x6f\x63\x61\x6c")){
cleanDb ();}}sub NXClusterTools::restoreSSHKeys{package NXClusterTools;no 
warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x73\x74\x6f\x72\x65\x20\x53\x53\x48\x20\x6b\x65\x79\x73\x2e"
);(my $keyRestored=(0x099d+ 162-0x0a3f));restoreSSHHostKeyDSAPrivate ((
\$keyRestored));restoreSSHHostKeyDSAPublic ((\$keyRestored));
restoreSSHHostKeyRSAPrivate ((\$keyRestored));restoreSSHHostKeyRSAPublic ((
\$keyRestored));restoreSSHHostKeyECDSAPrivate ((\$keyRestored));
restoreSSHHostKeyECDSAPublic ((\$keyRestored));restoreSSHHostKeyED25519Private (
(\$keyRestored));restoreSSHHostKeyED25519Public ((\$keyRestored));if ((
$keyRestored==(0x23c4+ 453-0x2588))){restartSshd ();}}sub 
NXClusterTools::addClusterKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights
=$NXBits::UserReadWrite);return (__appendFile ($file,$rights,$fileContent,
(0x0a6d+ 4048-0x18bd)));}sub NXClusterTools::setNodesDB{package NXClusterTools;
no warnings;(my $base=shift (@_));if (((not (defined ($base)))or ($base eq (""))
)){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x6e\x6f\x64\x65\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x73");
NXNodes::cleanDb ();return (NXNodes::setDatabaseByString ($base));}sub 
NXClusterTools::setProfilesDB{package NXClusterTools;no warnings;(my $base=shift
 (@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x70\x72\x6f\x66\x69\x6c\x65\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");NXProfilesDB::cleanDb ();
return (NXProfilesDB::setDatabaseByString ($base));}sub 
NXClusterTools::setProfileServersDB{package NXClusterTools;no warnings;(my $base
=shift (@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x70\x72\x6f\x66\x69\x6c\x65\x73\x20\x73\x65\x72\x76\x65\x72\x20\x73\x65\x74\x2e"
);return ((""));}main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");return (
NXProfilesDB::setProfilesServerSetByString ($base));}sub 
NXClusterTools::setProfileGroupDB{package NXClusterTools;no warnings;(my $base=
shift (@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x70\x72\x6f\x66\x69\x6c\x65\x73\x20\x67\x72\x6f\x75\x70\x20\x73\x65\x74\x2e"
);return ((""));}main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");return (
NXProfilesDB::setProfilesGroupSetByString ($base));}sub 
NXClusterTools::setUsersDB{package NXClusterTools;no warnings;(my $base=shift (
@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x75\x73\x65\x72\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");
NXUsersManager::cleanDb ();return (NXUsersManager::setDatabaseByString ($base));
}sub NXClusterTools::setAdministratorsDB{package NXClusterTools;no warnings;(my $base
=shift (@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);NXAdministratorsManager::cleanDb ();return (
NXAdministratorsManager::setDatabaseByString ($base));}sub 
NXClusterTools::setGroupsDB{package NXClusterTools;no warnings;(my $base=shift (
@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x67\x72\x6f\x75\x70\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire ("\x4e\x58\x47\x72\x6f\x75\x70\x73");
NXGroups::cleanDb ();return (NXGroups::setDatabaseByString ($base));}sub 
NXClusterTools::setNXCertsDB{package NXClusterTools;no warnings;(my $base=shift 
(@_));if (((not (defined ($base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x4e\x58\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return
 (NXServers::setNXCertsByString ($base));}sub NXClusterTools::setSSHCertsDB{
package NXClusterTools;no warnings;(my $base=shift (@_));if (((not (defined (
$base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x53\x53\x48\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return
 (NXServers::setSSHCertsByString ($base));}sub NXClusterTools::setNetworkDB{
package NXClusterTools;no warnings;(my $base=shift (@_));if (((not (defined (
$base)))or ($base eq ("")))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x65\x6d\x70\x74\x79\x20\x6e\x65\x74\x77\x6f\x72\x6b\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((""));}main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x52\x65\x64\x69\x73");return (
NXNetworkRedis::setDatabaseByString ($base));}sub 
NXClusterTools::setServerDSAPublicKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerDSAPublicKey ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));return (
__setFile ($file,$rights,$fileContent,(0x08e1+ 7490-0x247f)));}sub 
NXClusterTools::setServerDSAPrivateKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerDSAPrivateKey ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x2011+ 1271-0x2388)));}sub NXClusterTools::setServerRSAPublicKey{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerRSAPublicKey ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x082d+ 2379-0x0fd4)));}sub NXClusterTools::setServerRSAPrivateKey
{package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerRSAPrivateKey ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0745+ 2745-0x107e)));}sub 
NXClusterTools::setClientCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getUserNXKnownCerts ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x12fd+ 216-0x1255)));}sub NXClusterTools::setAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0985+ 3107-0x1428)));}sub NXClusterTools::setSSHAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $dir=
NXPaths::getSSHAuthorizedCertsDir ());if ((not (Common::NXFile::directoryExists 
($dir)))){my ($error);if ((not (Common::NXPaths::createAccessibleForNXDirectory 
((\$error),$dir)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72"
,"\x53\x53\x48",$dir);return ((0x00d4+ 2793-0x0bbc));}
changeFileOwnershipToNxIfRoot ($dir);}(my $file=NXPaths::getNodePublicKeys ());(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x1e23+ 952-0x205b)));}sub NXClusterTools::addSSHAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNodePublicKeys ());if (Common::NXFile::fileExists ($file)){my (
$error);if ((Common::NXFile::setPermissionsReadWriteForNX ($file,(\$error))==(-
(0x14e6+ 1058-0x1907)))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20\x27"
.$file)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error).
"\x27\x2e"));return ((0x1c4b+  90-0x1ca4));}}(my $rights=$NXBits::UserReadWrite)
;return (__appendFile ($file,$rights,$fileContent,(0x08f9+ 1062-0x0b9f)));}sub 
NXClusterTools::setHostPrivateCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0e29+ 1080-0x10e1)));}sub NXClusterTools::setHostPublicCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPublicCert ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x1e1c+ 1239-0x2173)));}sub 
NXClusterTools::setClusterMasterCertPub{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getClusterHostPublicCert ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));return (
__setFile ($file,$rights,$fileContent,(0x02d5+ 1181-0x05ce)));}sub 
NXClusterTools::setClusterMasterCertPriv{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getClusterHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0a7a+ 2610-0x132c)));}sub NXClusterTools::setKnownHostsSSH{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserKnownHostsSSH ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0c3b+ 5608-0x20a3)));}sub 
NXClusterTools::__setSSHHostKey{package NXClusterTools;no warnings;(my $content=
shift (@_));(my $algorithm=shift (@_));(my $type=shift (@_));(my $ref_keySet=
shift (@_));if (($content eq (""))){return ((0x03a9+ 2195-0x0c3c));}my (
$fileContent);if (($type eq "\x70\x72\x69\x76\x61\x74\x65")){($fileContent=
__getSSHHostKeyPrivate ($algorithm));}else{($fileContent=__getSSHHostKeyPublic (
$algorithm));}(my $fileMd5=Common::NXCore::digestMd5Hex ($fileContent));(my $contentMd5
=Common::NXCore::digestMd5Hex ($content));if (($fileMd5 eq $contentMd5)){
Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x6b\x69\x70\x20\x73\x65\x74\x74\x69\x6e\x67\x20\x53\x53\x48\x20\x68\x6f\x73\x74\x20\x6b\x65\x79\x20\x27"
.$algorithm).
"\x27\x20\x77\x69\x74\x68\x20\x74\x68\x65\x20\x73\x61\x6d\x65\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e"
));return ((0x09e8+ 1740-0x10b4));}(my $path=__setContentFile ($content));if ((
$path eq undef)){Logger::error (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x6e\x74\x65\x6e\x74\x20\x66\x69\x6c\x65\x2e"
);return ((0x00da+ 9077-0x244e));}(my (@command)=());(my (@parameters)=());push 
(@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXSSHHOSTCERTSET);push (
@command,$algorithm);push (@command,$type);(my ($cmdErr,$cmdOut,$exitValue)=
main::run_command ((\@command),(\@parameters)));Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x20\x53\x53\x48\x20\x68\x6f\x73\x74\x20\x6b\x65\x79\x20\x70\x72\x69\x76\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
.$cmdErr)."\x2c\x20").$cmdOut)."\x2c\x20").$exitValue)."\x2e"));if (
Common::NXFile::isExists ($path)){Common::NXFile::removeFile ($path);}(
$$ref_keySet=(0x070f+ 2239-0x0fcd));return ((0x07bf+ 6524-0x213b));}sub 
NXClusterTools::__restoreSSHHostKey{package NXClusterTools;no warnings;(my $algorithm
=shift (@_));(my $type=shift (@_));(my $ref_keyRestored=shift (@_));(my (
@command)=());(my (@parameters)=());push (@command,$GLOBAL::CommandNXexec,
$GLOBAL::SCRIPT_NXSSHHOSTRESTORE);push (@command,$algorithm);push (@command,
$type);(my ($cmdErr,$cmdOut,$exitValue)=main::run_command ((\@command),(
\@parameters)));Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x73\x74\x6f\x72\x65\x20\x53\x53\x48\x20\x68\x6f\x73\x74\x20\x6b\x65\x79\x20\x70\x72\x69\x76\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
.$cmdErr)."\x2c\x20").$cmdOut)."\x2c\x20").$exitValue)."\x2e"));if ((not ((
$cmdOut=~ /Nothing to restore/ )))){($$ref_keyRestored=(0x1584+ 4144-0x25b3));}
return ((0x0a89+ 6868-0x255d));}sub NXClusterTools::setSSHHostKeyDSAPrivate{
package NXClusterTools;no warnings;(my $content=shift (@_));(my $ref_keySet=
shift (@_));return (__setSSHHostKey ($content,"\x44\x53\x41",
"\x70\x72\x69\x76\x61\x74\x65",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $ref_keyRestored
=shift (@_));return (__restoreSSHHostKey ("\x44\x53\x41",
"\x70\x72\x69\x76\x61\x74\x65",$ref_keyRestored));}sub 
NXClusterTools::setSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $content
=shift (@_));(my $ref_keySet=shift (@_));return (__setSSHHostKey ($content,
"\x44\x53\x41","\x70\x75\x62\x6c\x69\x63",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $ref_keyRestored
=shift (@_));return (__restoreSSHHostKey ("\x44\x53\x41",
"\x70\x75\x62\x6c\x69\x63",$ref_keyRestored));}sub 
NXClusterTools::setSSHHostKeyRSAPrivate{package NXClusterTools;no warnings;(my $content
=shift (@_));(my $ref_keySet=shift (@_));return (__setSSHHostKey ($content,
"\x52\x53\x41","\x70\x72\x69\x76\x61\x74\x65",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyRSAPrivate{package NXClusterTools;no warnings;(my $ref_keyRestored
=shift (@_));return (__restoreSSHHostKey ("\x52\x53\x41",
"\x70\x72\x69\x76\x61\x74\x65",$ref_keyRestored));}sub 
NXClusterTools::setSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $content
=shift (@_));(my $ref_keySet=shift (@_));return (__setSSHHostKey ($content,
"\x52\x53\x41","\x70\x75\x62\x6c\x69\x63",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $ref_keyRestored
=shift (@_));return (__restoreSSHHostKey ("\x52\x53\x41",
"\x70\x75\x62\x6c\x69\x63",$ref_keyRestored));}sub 
NXClusterTools::setSSHHostKeyECDSAPrivate{package NXClusterTools;no warnings;(my $content
=shift (@_));(my $ref_keySet=shift (@_));return (__setSSHHostKey ($content,
"\x45\x43\x44\x53\x41","\x70\x72\x69\x76\x61\x74\x65",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyECDSAPrivate{package NXClusterTools;no warnings
;(my $ref_keyRestored=shift (@_));return (__restoreSSHHostKey (
"\x45\x43\x44\x53\x41","\x70\x72\x69\x76\x61\x74\x65",$ref_keyRestored));}sub 
NXClusterTools::setSSHHostKeyECDSAPublic{package NXClusterTools;no warnings;(my $content
=shift (@_));(my $ref_keySet=shift (@_));return (__setSSHHostKey ($content,
"\x45\x43\x44\x53\x41","\x70\x75\x62\x6c\x69\x63",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyECDSAPublic{package NXClusterTools;no warnings;
(my $ref_keyRestored=shift (@_));return (__restoreSSHHostKey (
"\x45\x43\x44\x53\x41","\x70\x75\x62\x6c\x69\x63",$ref_keyRestored));}sub 
NXClusterTools::setSSHHostKeyED25519Private{package NXClusterTools;no warnings;(my $content
=shift (@_));(my $ref_keySet=shift (@_));return (__setSSHHostKey ($content,
"\x45\x44\x32\x35\x35\x31\x39","\x70\x72\x69\x76\x61\x74\x65",$ref_keySet));}sub
 NXClusterTools::restoreSSHHostKeyED25519Private{package NXClusterTools;no 
warnings;(my $ref_keyRestored=shift (@_));return (__restoreSSHHostKey (
"\x45\x44\x32\x35\x35\x31\x39","\x70\x72\x69\x76\x61\x74\x65",$ref_keyRestored))
;}sub NXClusterTools::setSSHHostKeyED25519Public{package NXClusterTools;no 
warnings;(my $content=shift (@_));(my $ref_keySet=shift (@_));return (
__setSSHHostKey ($content,"\x45\x44\x32\x35\x35\x31\x39",
"\x70\x75\x62\x6c\x69\x63",$ref_keySet));}sub 
NXClusterTools::restoreSSHHostKeyED25519Public{package NXClusterTools;no 
warnings;(my $ref_keyRestored=shift (@_));return (__restoreSSHHostKey (
"\x45\x44\x32\x35\x35\x31\x39","\x70\x75\x62\x6c\x69\x63",$ref_keyRestored));}
sub NXClusterTools::__backupPrevious{package NXClusterTools;no warnings;(my $path
=shift (@_));(my $rights=shift (@_));(my $owner=shift (@_));(my $body=shift (@_)
);if ((not (Common::NXFile::fileExists ($path)))){(my $emptyFile=($path.
"\x2e\x65\x6d\x70\x74\x79"));(my $FH=main::nxopen ($emptyFile,($NXBits::O_RDWR+
$NXBits::O_CREAT),(($NXBits::OthersRead+$NXBits::UserReadWrite)+
$NXBits::GroupRead)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x27"
.$emptyFile)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorString).
"\x2e"));return ((0x07d5+ 6123-0x1fbf));}main::nxclose ($FH);if (($owner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($emptyFile);}return (
(0x0e72+ 2379-0x17bd));}(my $backup=($path."\x2e\x62\x61\x63\x6b\x75\x70"));if (
Common::NXFile::fileExists ($backup)){($backup.=("\x2d".NXTools::getTimeMs ()));
}if (($body ne (""))){(my $FH=main::nxopen ($backup,($NXBits::O_RDWR+
$NXBits::O_CREAT),$NXBits::UserReadWrite));if ((not (defined ($FH)))){(my $errorNumber
=libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x27"
.$backup)."\x27\x2e"));Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20").$errorString)."\x2e"));return ((0x1fc9+ 257-0x20c9));
}if ((main::nxwrite ($FH,$body)==(-(0x1996+ 3292-0x2671)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$backup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($FH);if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($backup);}return ((0x0f46+ 2264-0x181d));}
main::nxclose ($FH);if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($backup);}return ((0x1d81+ 523-0x1f8c));}else{(my (
$retValue,$outMsg)=Common::NXCore::copyFile ($path,$backup));if (($outMsg ne 
(""))){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x27".$path).
"\x27\x20\x74\x6f\x20\x27").$backup).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$outMsg)."\x27\x2e"));
return ((0x0183+ 6609-0x1b53));}}my ($error);if ((Common::NXFile::setPermission 
($backup,$rights,(\$error))==(-(0x1fc9+ 1823-0x26e7)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20"
.$backup)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error)."\x27\x2e"
));return ((0x07a8+ 895-0x0b26));}unless (Common::NXFile::fileExists ($backup)){
Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$backup)."\x27\x20\x66\x6f\x72\x20\x27").$path)."\x27\x2e"));return (
(0x000b+ 7502-0x1d58));}if ((($owner ne "\x72\x6f\x6f\x74")and ($owner ne 
"\x6e\x78\x68\x74\x64"))){changeFileOwnershipToNxIfRoot ($backup);}return (
(0x1a2d+ 2158-0x229b));}sub NXClusterTools::__setContentFile{package 
NXClusterTools;no warnings;(my $body=shift (@_));(my $path=($ENV{
"\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d"}.
"\x2f\x76\x61\x72\x2f\x72\x75\x6e\x2f\x73\x73\x68\x68\x6f\x73\x74\x63\x65\x72\x74"
));(my $mode=($NXBits::O_RDWR+$NXBits::O_CREAT));(my $permissions=
$NXBits::UserReadWrite);(my $FD=main::nxopen ($path,$mode,$permissions));unless 
(defined ($FD)){Logger::error (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x20\x27"
.$path)."\x27\x2e"));return (undef);}if ((main::nxwrite ($FD,$body)==(-
(0x0dd6+ 2224-0x1685)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$path)."\x27\x2e"));Logger::error (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20"
.$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($FD);return (
undef);}main::nxclose ($FD);return ($path);}sub NXClusterTools::__setFile{
package NXClusterTools;no warnings;(my $file=shift (@_));(my $rights=shift (@_))
;(my $fileBody=shift (@_));(my $backupRights=shift (@_));(my $backupOwner=shift 
(@_));(my $fileContent=shift (@_));if (($fileContent eq (""))){($fileContent=
Common::NXFile::getFileContent ($file));}(my $fileMd5=
Common::NXCore::digestMd5Hex ($fileContent));(my $bodyMd5=
Common::NXCore::digestMd5Hex ($fileBody));if (($fileMd5 eq $bodyMd5)){
Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x6b\x69\x70\x20\x73\x65\x74\x74\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file).
"\x27\x20\x77\x69\x74\x68\x20\x74\x68\x65\x20\x73\x61\x6d\x65\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e"
));return ((0x1801+ 3321-0x24fa));}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x2e"));if (__backupPrevious ($file,$backupRights,$backupOwner,
$fileContent)){return ((0x14dc+ 2260-0x1daf));}(my $fileBackup=($file.
"\x2e\x74\x6d\x70"));(my $FD=main::nxopen ($fileBackup,($NXBits::O_WRONLY+
$NXBits::O_CREAT),$rights));unless (defined ($FD)){Logger::error (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x20\x27"
.$fileBackup)."\x27\x2e"));return ((0x12c6+ 254-0x13c3));}if ((main::nxwrite (
$FD,$fileBody)==(-(0x0a75+ 1041-0x0e85)))){(my $errorNumber=libnxh::NXGetError 
());(my $errorstring=libnxh::NXGetErrorString ());Logger::error (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));Logger::error (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20"
.$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($FD);if (((
$backupOwner ne "\x72\x6f\x6f\x74")and ($backupOwner ne "\x6e\x78\x68\x74\x64"))
){changeFileOwnershipToNxIfRoot ($fileBackup);}return ((0x012d+ 9300-0x2580));}
main::nxclose ($FD);if ((($backupOwner ne "\x72\x6f\x6f\x74")and ($backupOwner 
ne "\x6e\x78\x68\x74\x64"))){changeFileOwnershipToNxIfRoot ($fileBackup);}unless
 (rename ($fileBackup,$file)){Logger::error (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$!)."\x27\x2e"));return 
((0x0759+ 5751-0x1dcf));}return ((0x00c3+ 7425-0x1dc4));}sub 
NXClusterTools::__appendFile{package NXClusterTools;no warnings;(my $file=shift 
(@_));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $rightBackup=shift (
@_));(my $ownerBackup=shift (@_));if (__backupPrevious ($file,$rightBackup,
$ownerBackup)){return ((0x076b+ 2946-0x12ec));}(my $fileExisted=
(0x1bcc+ 321-0x1d0d));if (Common::NXFile::fileExists ($file)){($fileExisted=
(0x0a4d+ 6787-0x24cf));}(my $fileDesc=main::nxopen ($file,(($NXBits::O_WRONLY+
$NXBits::O_CREAT)+$NXBits::O_APPEND),$rights));unless (defined ($fileDesc)){
Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x74\x6f\x20\x61\x70\x70\x65\x6e\x64\x2e"));return (
(0x0cb2+ 1909-0x1426));}if ((main::nxwrite ($fileDesc,$fileBody)==(-
(0x1c48+ 217-0x1d20)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".
$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((
not ($fileExisted))){if (($ownerBackup ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x0166+ 614-0x03cb));}
main::nxclose ($fileDesc);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($file);}return ((0x0c34+ 569-0x0e6d));}sub 
NXClusterTools::__addClusterNodeKey{package NXClusterTools;no warnings;(my $message
=shift (@_));($message=main::urldecode ($message));return (addClusterKey (
$message));}sub NXClusterTools::checkUserNXConfigDir{package NXClusterTools;no 
warnings;(my $path=NXPaths::getConfigDir ());unless (
Common::NXFile::directoryExists ($path)){my ($error);unless (
Common::NXPaths::createAccessibleForNXDirectory ((\$error),$path)){return (
(0x1760+ 3622-0x2586));}}return ((0x0061+ 9531-0x259b));}sub 
NXClusterTools::prepareNXKnownCerts{package NXClusterTools;no warnings;(my $refClusterHash
=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x50\x72\x65\x70\x61\x72\x69\x6e\x67\x20\x4e\x58\x20\x6b\x6e\x6f\x77\x6e\x20\x63\x65\x72\x74\x73\x2e"
);my ($file);foreach my $key (keys (%$refClusterHash)){(my $value=
$$refClusterHash{$key});chomp ($value);if (($value eq (""))){next;}while (
Common::NXShellCreate::isHostInCertFile ($key,NXPaths::getCurrentUserKnownCerts 
())){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x66\x6f\x72\x20\x68\x6f\x73\x74\x20\x27"
.$key)."\x27\x2e"));Common::NXShellCreate::removeCertificate ($key,
NXPaths::getCurrentUserKnownCerts ());}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x41\x64\x64\x69\x6e\x67\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x20\x66\x6f\x72\x20\x68\x6f\x73\x74\x20\x27"
.$key)."\x27\x2e"));($file.=(((("\x48\x6f\x73\x74\x3a".$key)."\x0a").$value).
"\x0a"));}if (($GLOBAL::ClusterLocalIp ne (""))){(my $myCert=getHostPublicCert 
());chomp ($myCert);while (Common::NXShellCreate::isHostInCertFile (
$GLOBAL::ClusterLocalIp,NXPaths::getCurrentUserKnownCerts ())){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x6c\x6f\x63\x61\x6c\x20\x49\x50\x20\x27"
.$GLOBAL::ClusterLocalIp).
"\x27\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e"));
Common::NXShellCreate::removeCertificate ($GLOBAL::ClusterLocalIp,
NXPaths::getCurrentUserKnownCerts ());}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x41\x64\x64\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x6c\x6f\x63\x61\x6c\x20\x49\x50\x20\x27"
.$GLOBAL::ClusterLocalIp).
"\x27\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e"));($file.=((((
"\x48\x6f\x73\x74\x3a".$GLOBAL::ClusterLocalIp)."\x0a").$myCert)."\x0a"));}(my $hostCert
=getClusterMasterCertPub ());if (NXCluster::isSingleCert ()){($hostCert=
getHostPublicCert ());}chomp ($hostCert);while (
Common::NXShellCreate::isHostInCertFile ($GLOBAL::ClusterMaster,
NXPaths::getCurrentUserKnownCerts ())){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x68\x6f\x73\x74\x20\x27"
.$GLOBAL::ClusterMaster).
"\x27\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e"));
Common::NXShellCreate::removeCertificate ($GLOBAL::ClusterMaster,
NXPaths::getCurrentUserKnownCerts ());}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x41\x64\x64\x69\x6e\x67\x20\x68\x6f\x73\x74\x20\x27"
.$GLOBAL::ClusterMaster).
"\x27\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e"));($file.=((((
"\x48\x6f\x73\x74\x3a".$GLOBAL::ClusterMaster)."\x0a").$hostCert)."\x0a"));(
$file.=getPlayerCerts ());setClientCerts ($file);(my $path=
NXPaths::getUserNXKnownCerts ());changeFileOwnershipToNxIfRoot ($path);return (
$file);}sub NXClusterTools::__preparePublicKeys{package NXClusterTools;no 
warnings;(my $ref_publicKeys=shift (@_));(my $protocol=shift (@_));Logger::debug
 (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x50\x72\x65\x70\x61\x72\x65\x20\x70\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x73\x2e"
);(my $file=(""));my ($filePath);if (($protocol eq "\x53\x53\x48")){($filePath=
NXPaths::getNodePublicKeys ());}else{($filePath=NXPaths::getNXAuthorizedKeysPath
 ("\x6e\x78"));}(my $fileContent=Common::NXFile::getFileContent ($filePath));(my (
@oldContent)=split ( /\n/ ,$fileContent,(0x101f+ 1528-0x1617)));(my $prefix=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=(("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH));($prefix.=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
);foreach my $key (keys (%$ref_publicKeys)){(my $potentialKey=$$ref_publicKeys{
$key});(my $add=(0x156d+ 4135-0x2593));chomp ($potentialKey);($potentialKey=~ s/\r//g )
;if (($protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}
else{($potentialKey.=
"\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x43\x6c\x75\x73\x74\x65\x72");}foreach my $line
 (@oldContent){chomp ($line);($line=~ s/\r//g );if (($potentialKey eq $line)){(
$add=(0x07ea+ 137-0x0873));last;}}if (($add==(0x06bc+ 7741-0x24f8))){($file.=(
$potentialKey."\x0a"));}}(my $potentialKey=getClusterPublicKey ());chomp (
$potentialKey);($potentialKey=~ s/\r//g );if (($protocol eq "\x53\x53\x48")){(
$potentialKey=($prefix.$potentialKey));}else{($potentialKey.=
"\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x43\x6c\x75\x73\x74\x65\x72");}(my $add
=(0x0069+ 636-0x02e4));foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g )
;if (($potentialKey eq $line)){($add=(0x0c1b+ 4450-0x1d7d));last;}}if (($add==
(0x03e2+ 6429-0x1cfe))){($file.=($potentialKey."\x0a"));}($file.=$fileContent);
if (($protocol eq "\x53\x53\x48")){setSSHAuthorizedCerts ($file);}else{
setAuthorizedCerts ($file);}return ($file);}sub 
NXClusterTools::prepareNXDPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x4e\x58"));}sub 
NXClusterTools::prepareSSHPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x53\x53\x48"));}sub 
NXClusterTools::prepareSSHClusterKey{package NXClusterTools;no warnings;(my $prefix
=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=((("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
));(my $key=($prefix.getClusterPublicKey ()));return ($key);}sub 
NXClusterTools::prepareKnownHostsSSH{package NXClusterTools;no warnings;(my $certificate
=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x50\x72\x65\x70\x61\x72\x65\x20\x6b\x6e\x6f\x77\x6e\x20\x68\x6f\x73\x74\x73\x20\x66\x69\x6c\x65\x2e"
);($certificate=~ s/\015//gs );my ($file);if (($certificate ne (""))){($file=(((
((($GLOBAL::ClusterPool."\x2c").$GLOBAL::ClusterMaster)."\x2c").
$GLOBAL::ClusterSlave)."\x20").$certificate));}(my (@hosts)=split ( /,/ ,
$GLOBAL::ClusterPool,(0x1cb2+ 1662-0x2330)));foreach my $host (@hosts){
Common::NXShellCreate::removeCertificateSSH ($host,NXPaths::getUserKnownHostsSSH
 ());NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x65\x72\x74\x73\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x53\x53\x48\x48\x6f\x73\x74\x43\x65\x72\x74\x0a"))
;}($file.=getUserKnownHostsSSH ());setKnownHostsSSH ($file);return ($file);}sub 
NXClusterTools::checkKeys{package NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x66\x69\x6c\x65\x73\x2e"
);if ((not (Common::NXFile::fileExists (NXPaths::getClusterRSAPrivateKey ())))){
generateClusterKeys ();}if ((not (Common::NXFile::fileExists (
NXPaths::getClusterRSAPublicKey ())))){generateClusterKeys ();}if ((not (
Common::NXFile::fileExists (NXPaths::getClusterHostPublicCert ())))){
generateClusterHostCerts ();}if ((not (Common::NXFile::fileExists (
NXPaths::getClusterHostPrivateCert ())))){generateClusterHostCerts ();}}sub 
NXClusterTools::changeFileOwnershipToNxIfRoot{package NXClusterTools;no warnings
;(my $file=shift (@_));if (isEffectiveUserRoot ()){Logger::debug2 (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x6e\x78\x20\x27"
.$file)."\x27\x2e"));my ($errorName);my ($errorCode);if ((
Common::NXFile::setOwnershipForUserSilent ($file,"\x6e\x78",(\$errorName),(
\$errorCode))==(-(0x012a+ 7580-0x1ec5)))){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",(
($file."\x2e\x20").$errorName));unlink ($file);main::nxexit (
(0x0fe0+ 1939-0x1773));}}return ((0x20e9+ 415-0x2288));}sub 
NXClusterTools::isEffectiveUserRoot{package NXClusterTools;no warnings;(my $user
=Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){
return ((0x0d11+ 2911-0x186f));}return ((0x1bc8+ 2338-0x24ea));}sub 
NXClusterTools::__getPathToPublicKey{package NXClusterTools;no warnings;if (
__isRSAKeyAvailable ()){return (NXPaths::getClusterRSAPrivateKey ());}return (
NXPaths::getClusterDSAPrivateKey ());}sub NXClusterTools::getDatabaseInString{
package NXClusterTools;no warnings;(my $request=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65"
);($request.=
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44"
);($request.=
"\x2c\x66\x69\x65\x6c\x64\x3d\x6c\x6f\x61\x64\x42\x61\x6c\x61\x6e\x63\x69\x6e\x67\x2c\x66\x69\x65\x6c\x64\x3d\x73\x69\x6e\x67\x6c\x65\x43\x65\x72\x74\x2c\x66\x69\x65\x6c\x64\x3d\x73\x6c\x61\x76\x65\x0a"
);(my $databaseString=(""));NXRedis::sendToDb ($request);(my $config=
NXRedis::get ());($config=~ s/ /,/g );($databaseString.=($config."\x0a"));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my $clusterList=NXRedis::get ());(my (@list)=split ( / / ,$clusterList,
(0x0ce4+ 5949-0x2421)));foreach my $host (@list){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x2c\x66\x69\x65\x6c\x64\x3d\x75\x75\x69\x64\x2c\x66\x69\x65\x6c\x64\x3d\x6f\x73\x0a"
));(my $line=NXRedis::get ());($line=~ s/ /,/g );($databaseString.=($line."\x0a"
));}return ($databaseString);}sub NXClusterTools::setDatabaseByString{package 
NXClusterTools;no warnings;(my $string=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x62\x79\x20\x73\x74\x72\x69\x6e\x67\x2e"
);(my (@clusterList)=split ( /\n/ ,$string,(0x0d31+ 4852-0x2025)));(my $redisString
=__setConfigLine ($clusterList[(0x091d+ 737-0x0bfe)]));NXRedis::sendToDb (
$redisString);(my ($host1data,$host1set)=__setHostLineS ($clusterList[
(0x0c9d+ 2520-0x1674)]));NXRedis::sendToDb ($host1data);NXRedis::sendToDb (
$host1set);(my ($host2data,$host2set)=__setHostLineS ($clusterList[
(0x02cc+ 755-0x05bd)]));NXRedis::sendToDb ($host2data);NXRedis::sendToDb (
$host2set);return ((0x00cc+ 5199-0x151b));}sub NXClusterTools::__setConfigLine{
package NXClusterTools;no warnings;(my $configLine=shift (@_));(my $record=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67"
);(my (@options)=split ( /,/ ,$configLine,(0x0436+ 3726-0x12c4)));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x1448+ 3850-0x2352)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x01d2+ 5071-0x15a0)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0287+ 6993-0x1dd6)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x02c3+ 3488-0x1060)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0bb9+ 6709-0x25ea)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x02c5+ 5422-0x17ee)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0951+ 7073-0x24ec)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x14d2+ 1915-0x1c46)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0466+ 3850-0x1368)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0253+ 6775-0x1cc1)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6c\x6f\x61\x64\x42\x61\x6c\x61\x6e\x63\x69\x6e\x67\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x19bf+ 1869-0x2102)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x69\x6e\x67\x6c\x65\x43\x65\x72\x74\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0cc7+ 192-0x0d7c)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x6c\x61\x76\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x01a5+ 6416-0x1aa9)]));($record.="\x0a");return ($record);}sub 
NXClusterTools::__setHostLineS{package NXClusterTools;no warnings;(my $hostLine=
shift (@_));(my (@host)=split ( /,/ ,$hostLine,(0x01e3+ 5161-0x160c)));(my $record
=(
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host[(0x1643+ 2103-0x1e7a)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x76\x61\x6c\x75\x65\x3d".$host
[(0x10c9+ 2894-0x1c17)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x0862+ 4409-0x199a)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x1c75+ 2224-0x2523)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x75\x75\x69\x64\x2c\x76\x61\x6c\x75\x65\x3d".$host
[(0x0891+ 593-0x0adf)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6f\x73\x2c\x76\x61\x6c\x75\x65\x3d".$host[
(0x0bdb+ 6578-0x2589)]));($record.="\x0a");(my $setRecord=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x64\x64\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d"
.$host[(0x1f1a+ 1449-0x24c3)])."\x0a"));return ($record,$setRecord);}sub 
NXClusterTools::cleanDb{package NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x6c\x65\x61\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my (@hosts)=split ( / / ,NXRedis::get (),(0x0295+ 1014-0x068b)));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);foreach my $host (@hosts){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host)."\x0a"));}NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x0a"
);return ((0x0e21+ 5563-0x23dc));}sub NXClusterTools::getServerCfgFile{package 
NXClusterTools;no warnings;(my $file=$GLOBAL::CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setServerCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+$NXBits::GroupRead)+
$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,(0x124f+ 297-0x11d4)
);return ((0x0f49+ 1937-0x16da));}sub NXClusterTools::getNodeCfgFile{package 
NXClusterTools;no warnings;(my $file=$GLOBAL::NODE_CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setNodeCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::NODE_CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x1440+ 5201-0x26ed));return ((0x1641+ 1406-0x1bbf));}sub NXClusterTools::sync{
package NXClusterTools;no warnings;if (($GLOBAL::ClusterSyncDisabled==
(0x1778+ 1787-0x1e72))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x73\x79\x6e\x63\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e"
);return ((0x02ab+ 3896-0x11e2));}main::nxrequire (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72");if ((not (NXCluster::isClusterConfigured
 ()))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x6b\x69\x70\x20\x73\x79\x6e\x63\x20\x66\x6f\x72\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x66\x69\x67\x75\x72\x65\x64\x20\x63\x6c\x75\x73\x74\x65\x72\x2e"
);return;}Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x73\x79\x6e\x63\x2e"
);(my (@command)=());push (@command,($GLOBAL::ETC_DIR.
"\x2f\x6e\x78\x73\x65\x72\x76\x65\x72"));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){push
 (@command,"\x2d\x2d\x63\x6c\x75\x73\x74\x65\x72\x65\x64\x69\x74",
"\x2d\x2d\x66\x69\x6c\x65\x73");}else{push (@command,
"\x2d\x2d\x73\x79\x6e\x63\x68\x72\x6f\x6e\x69\x7a\x65");}(my (@options)=());(my $logfile
=Common::NXPaths::getNXServerLogPath ());push (@options,
"\x73\x74\x64\x65\x72\x72",$logfile);push (@options,"\x73\x74\x64\x6f\x75\x74",
$logfile);push (@options,"\x74\x69\x6d\x65\x6f\x75\x74",
$GLOBAL::AuthorizationTimeout);push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53\x3d".libnxh::NXTransGetEnvironment
 ("\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53")));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e\x3d".
libnxh::NXTransGetEnvironment ("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e")));
NXMsg::info (
"\x69\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x53\x79\x6e\x63\x53\x74\x61\x72\x74"
);main::run_command ((\@command),(\@options));NXMsg::info (
"\x69\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x53\x79\x6e\x63\x45\x6e\x64");}sub
 NXClusterTools::getWebCfgFile{package NXClusterTools;no warnings;(my $file=
$GLOBAL::HTD_CONFIG_FILE);return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::setWebCfgFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=$GLOBAL::HTD_CONFIG_FILE);(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0eba+ 1923-0x1499),"\x6e\x78\x68\x74\x64");return 
(changeFileOwnershipToNxhtd ($file,"\x63\x6f\x6e\x66\x69\x67"));}sub 
NXClusterTools::setHttpHostPublicCertFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHttpHostPublicCert ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));(my $ret=
__setFile ($file,$rights,$fileContent,(0x16e6+ 2477-0x1eef),
"\x6e\x78\x68\x74\x64"));return (changeFileOwnershipToNxhtd ($file,
"\x70\x75\x62\x6c\x69\x63\x43\x65\x72\x74"));}sub 
NXClusterTools::setHttpHostPrivateCertFile{package NXClusterTools;no warnings;
Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x48\x54\x54\x50\x20\x70\x72\x69\x76\x61\x74\x65\x20\x63\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e"
);(my $fileContent=shift (@_));(my $file=NXPaths::getHttpHostPrivateCert ());(my $rights
=$NXBits::UserReadWrite);(my $orginalContent=(""));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user ne "\x72\x6f\x6f\x74")){(
$orginalContent=getHttpHostPrivateCertContent ());}(my $ret=__setFile ($file,
$rights,$fileContent,(0x19f2+ 3199-0x24f1),"\x6e\x78\x68\x74\x64",
$orginalContent));return (changeFileOwnershipToNxhtd ($file,
"\x70\x72\x69\x76\x61\x74\x65\x43\x65\x72\x74"));}sub 
NXClusterTools::setSessionHistoryFile{package NXClusterTools;no warnings;(my $newContent
=shift (@_));(my $file=NXPaths::getSessionHistoryFile ());(my $oldContent=
Common::NXFile::getFileContent ($file));(my $oldMd5=Common::NXCore::digestMd5Hex
 ($oldContent));(my $newMd5=Common::NXCore::digestMd5Hex ($newContent));if ((
$newMd5 eq $oldMd5)){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x6b\x69\x70\x20\x73\x65\x74\x74\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file).
"\x27\x20\x77\x69\x74\x68\x20\x74\x68\x65\x20\x73\x61\x6d\x65\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e"
));return ((0x1125+ 4249-0x21be));}(my $mode=($NXBits::O_WRONLY+$NXBits::O_TRUNC
));(my $rights=(($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)
);(my $fd=main::nxopen ($file,$mode,$rights));unless (defined ($fd)){
Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x20\x27"
.$file)."\x27\x2e"));return ((0x07f4+ 7815-0x267a));}if ((main::nxwrite ($fd,
$newContent)==(-(0x1047+ 3384-0x1d7e)))){(my $errorNumber=libnxh::NXGetError ())
;(my $errorstring=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($fd);changeFileOwnershipToNxIfRoot ($file)
;return ((0x191d+ 3264-0x25dc));}main::nxclose ($fd);
changeFileOwnershipToNxIfRoot ($file);return ((0x2189+ 556-0x23b5));}sub 
NXClusterTools::changeFileOwnershipToNxhtd{package NXClusterTools;no warnings;(my $file
=shift (@_));(my $param=shift (@_));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){(my (
@htdUsers)=NXTools::getNXHtdUser ());Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20"
.$htdUsers[(0x1dda+ 1702-0x2480)])."\x2c\x20").$file)."\x2e"));my ($errorName);my (
$errorCode);if ((Common::NXFile::setOwnershipForUserSilent ($file,$htdUsers[
(0x204f+ 1647-0x26be)],(\$errorName),(\$errorCode))==(-(0x0497+ 8529-0x25e7)))){
Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",(
($file."\x2e\x20").$errorName));unlink ($file);main::nxexit (
(0x0eb2+ 1472-0x1472));}}else{(my (@command)=());(my (@parameters)=());push (
@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXHTDCHOWN,$param);(my ($cmd_err
,$cmd_out,$exit_value)=main::run_command ((\@command),(\@parameters)));if ((
$exit_value!=(0x0917+ 5308-0x1dd3))){Logger::error (((((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27").
$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne 
(""))){($file.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
$file);main::nxexit ((0x0316+ 9165-0x26e3));}}return ((0x0a7f+ 901-0x0e04));}sub
 NXClusterTools::getHttpHostPrivateCertContent{package NXClusterTools;no 
warnings;(my $file=NXPaths::getHttpHostPrivateCert ());(my (@command)=());(my (
@parameters)=());push (@command,$GLOBAL::CommandNXexec,
$GLOBAL::SCRIPT_NXWEBHOSTCERTGET);(my ($cmd_err,$cmd_out,$exit_value)=
main::run_command ((\@command),(\@parameters)));if (($exit_value!=
(0x23f7+ 491-0x25e2))){Logger::error (((((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x66\x69\x6c\x65\x20\x27".$file).
"\x27\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27"
).$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne
 (""))){($file.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x46\x69\x6c\x65",$file);
main::nxexit ((0x041a+ 7732-0x224e));}return ($cmd_out);return ((""));}sub 
NXClusterTools::getNXDPublicKeys{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")));
}sub NXClusterTools::getSshPublicKeys{package NXClusterTools;no warnings;return 
(Common::NXFile::getFileContent (NXPaths::getNodePublicKeys ()));}sub 
NXClusterTools::getSessionHistory{package NXClusterTools;no warnings;(my $file=
Common::NXFile::getFileContent (NXPaths::getSessionHistoryFile ()));return (
main::urlencode ($file));}sub NXClusterTools::__getSSHHostKeyPublic{package 
NXClusterTools;no warnings;(my $algorithm=shift (@_));(my $path=
NXPaths::getSSHHostKeyPublicPath ($algorithm));return (
Common::NXFile::getFileContent ($path));}sub 
NXClusterTools::__getSSHHostKeyPrivate{package NXClusterTools;no warnings;(my $algorithm
=shift (@_));if (isEffectiveUserRoot ()){(my $path=
NXPaths::getSSHHostKeyPrivatePath ($algorithm));return (
Common::NXFile::getFileContent ($path));}(my (@command)=());(my (@parameters)=()
);push (@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXSSHHOSTCERTGET);push (
@command,$algorithm);(my ($cmd_err,$cmd_out,$exit_value)=main::run_command ((
\@command),(\@parameters)));if (($exit_value!=(0x03a4+ 2355-0x0cd7))){
Logger::error (((((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x53\x53\x48\x20\x68\x6f\x73\x74\x20\x6b\x65\x79\x20\x27"
.$algorithm).
"\x27\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27"
).$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne
 (""))){($path.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x46\x69\x6c\x65",$path);return (
(""));}return ($cmd_out);}sub NXClusterTools::removeNetworkInterfaceAliasNumber{
package NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x61\x6c\x69\x61\x73\x20\x6e\x75\x6d\x62\x65\x72\x20\x66\x72\x6f\x6d\x20\x6e\x65\x74\x77\x6f\x72\x6b\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6e\x61\x6d\x65\x2e"
);NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my $clusterList=NXRedis::get ());if (($clusterList eq (""))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x64\x6f\x65\x73\x6e\x27\x74\x20\x65\x78\x69\x73\x74\x2e"
);return ((0x130b+ 4284-0x23c6));}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x6c\x69\x73\x74\x20\x27"
.$clusterList)."\x27\x2e"));(my (@list)=split ( / / ,$clusterList,
(0x0a36+ 2683-0x14b1)));foreach my $host (@list){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host)."\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x0a"))
;(my $interface=main::urldecode (NXRedis::get ()));(my $newInterface=$interface)
;if (($newInterface=~ s/:\d+$// )){Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x61\x6c\x69\x61\x73\x20\x6e\x75\x6d\x62\x65\x72\x20\x66\x72\x6f\x6d\x20\x6e\x65\x74\x77\x6f\x72\x6b\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6e\x61\x6d\x65\x20\x27"
.$interface)."\x27\x2e"));($newInterface=main::urlencode ($newInterface));
NXRedis::sendToDb (((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x66\x69\x65\x6c\x64\x3d"
).$newInterface)."\x0a"));}}}sub NXClusterTools::restartSshd{package 
NXClusterTools;no warnings;if ((not (NXSystemDaemons::isSystemBasedOnSystemd ())
)){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x73\x74\x61\x72\x74\x20\x6f\x66\x20\x73\x73\x68\x64\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x65\x71\x75\x69\x72\x65\x64\x20\x66\x6f\x72\x20\x6e\x6f\x6e\x2d\x73\x79\x73\x74\x65\x6d\x64\x20\x62\x61\x73\x65\x64\x20\x73\x79\x73\x74\x65\x6d\x73\x2e"
);return ((0x072a+ 7798-0x25a0));}if (($GLOBAL::SshdRestartDisabled==
(0x04f7+ 302-0x0624))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x73\x74\x61\x72\x74\x20\x6f\x66\x20\x73\x73\x68\x64\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e"
);return ((0x0bc4+ 407-0x0d5b));}Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x52\x65\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x73\x73\x68\x64\x2e"
);(my (@command)=());(my (@parameters)=());push (@command,$GLOBAL::CommandNXexec
,$GLOBAL::SCRIPT_NXSSHRESTART);(my ($cmd_err,$cmd_out,$exit_value)=
main::run_command ((\@command),(\@parameters)));if (($exit_value!=
(0x0998+ 4439-0x1aef))){Logger::warning (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x74\x61\x72\x74\x20\x73\x73\x68\x64\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27"
.$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));return (
(0x13f9+ 3901-0x2335));}return ((0x1cac+ 2304-0x25ac));}package NXClusterTools;
no warnings;return ((0x14b5+ 3992-0x244c));
