############################################################################
#                                                                          #
#  Copyright (c) 2001, 2025 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub Logger::BEGIN{package Logger;no warnings;require Common::NXCore;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x43\x6f\x72\x65"->import};}package 
Logger;no warnings;require Common::NXFile;($debugMode=
"\x64\x69\x73\x61\x62\x6c\x65");($flagPrintProcessNamesToErrorsAndWarnings=
(0x0e01+ 5231-0x2270));(my $__whoami=
"\x4c\x6f\x67\x67\x65\x72\x3a\x3a\x6c\x6f\x67");sub BEGIN{require 
Common::NXPaths;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x50\x61\x74\x68\x73"->import};}sub 
BEGIN{require Common::NXTime;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x54\x69\x6d\x65"->import};}sub BEGIN{
require NXTools;do{"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};}(my (
%__no_log_packages)=());(my $__previousLogMessage=(""));(my $__previousLogMessageCount
=(0x0ccc+ 5648-0x22dc));(my $__previousStatusMessage=(""));(my $__previousStatusMessageCount
=(0x0282+ 8393-0x234b));(my $__doNotStoreInHistory=(0x017d+ 1243-0x0658));(my $__storeInHistory
=(0x0c0b+ 5639-0x2211));(@statusDumpBeginPart=());(@statusDumpEndPart=());(
$loggerWorking=(0x0f9a+ 5534-0x2537));($LOG_ERROR=(0x017c+ 1728-0x0839));(
$LOG_WARNING=(0x0058+ 835-0x0397));($LOG_NOTICE=(0x1313+ 3748-0x21b2));(
$LOG_INFO=(0x1f19+ 613-0x2178));($LOG_DEBUG=(0x0429+ 4872-0x172a));($LOG_DEBUG2=
(0x06bb+ 6617-0x208c));($LOG_DEBUG3=(0x14bc+ 3083-0x20be));(my $__level=
$LOG_INFO);sub init{(($__whoami,$__level)=@_);setLoggerInfo ();(my $message=((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x64\x20\x77\x69\x74\x68\x20\x61\x72\x67\x75\x6d\x65\x6e\x74\x73\x20\x27"
.NXBegin::getProcessArgumentsString ())."\x27\x2e"));debug ($message);statusPush
 ($message);}sub initLevel{(my $variables=libnxh::NXInitSyslogConstants ());(
$LOG_ERROR=@$variables[(0x08c1+ 5833-0x1f8a)]);($LOG_WARNING=@$variables[
(0x2281+ 985-0x2659)]);($LOG_NOTICE=@$variables[(0x082d+ 1579-0x0e56)]);(
$LOG_INFO=@$variables[(0x05fd+ 364-0x0766)]);($LOG_DEBUG=@$variables[
(0x0f22+ 2369-0x185f)]);($LOG_DEBUG2=@$variables[(0x187a+ 770-0x1b77)]);(
$LOG_DEBUG3=@$variables[(0x10e1+ 2173-0x1958)]);($__level=$LOG_INFO);}sub 
disablePackage{($Logger::__no_log_packages{$_[(0x14d9+ 1958-0x1c7f)]}="\x31");}
sub __statusPush{(my $message=shift (@_));(my $line=getFormattedLogLine (
$message));if ((scalar (@statusDumpBeginPart)>=(0x0c8c+ 1542-0x1260))){(my $length
=push (@statusDumpEndPart,$line));if (($length>(0x0bdd+ 455-0x0d72))){shift (
@statusDumpEndPart);}}else{push (@statusDumpBeginPart,$line);}}sub statusPush{if
 (($GLOBAL::EnableStatusDump==(0x16b7+ 3245-0x2363))){(my $message=shift (@_));
if (__suppressStatusDump ($message)){return;}__statusPush ($message);}}sub 
statusPushError{(my $message=shift (@_));($message=setMessageType ($message,
$LOG_ERROR));statusPush ($message);}sub statusPushWarning{(my $message=shift (@_
));($message=setMessageType ($message,$LOG_WARNING));statusPush ($message);}sub 
statusGet{(my $statusStr=join ((""),@statusDumpBeginPart));if (scalar (
@statusDumpEndPart)){($statusStr.=
"\x0a\x73\x6b\x69\x70\x70\x69\x6e\x67\x20\x2e\x2e\x2e\x0a\x0a");($statusStr.=
join ((""),@statusDumpEndPart));}return ($statusStr);}sub printStatus{(my ($msg,
$statusId,@status)=@_);main::nxwrite (main::nxgetSTDOUT (),((($msg."\x20\x5b").
$statusId)."\x5d\x0a"));while ((my $msg=shift (@status))){($msg=~ s/\n$//gm );(
$msg=~ s/\n/\n        /g );main::nxwrite (main::nxgetSTDOUT (),((
"\x20\x20\x20\x20".$msg)."\x0a"));}}sub logStatus{(my ($level,@msgs)=@_);(my (
$statusId,@status)=statusGet ());multilineLog ($statusId,@msgs,@status);return (
$statusId,@status);}sub __log{(my ($msg,$level,$storeInHistory)=@_);(my (
$package,$filename,$line,$sub)=caller ((0x215c+ 607-0x23b9)));if ((not (defined 
($level)))){main::nxwrite (main::nxgetSTDERR (),((((((((((
"\x4d\x69\x73\x73\x69\x6e\x67\x20\x6c\x6f\x67\x20\x6c\x65\x76\x65\x6c\x20\x66\x72\x6f\x6d\x3a\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub).
"\x29\x20\x61\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20").$msg)."\x0a"));
return;}if (($__level<$level)){if (($storeInHistory==(0x0bd0+ 1395-0x1142))){
storeInHistory ($msg,$level);}return;}if ((not (defined ($GLOBAL::CONFIG_FILE)))
){if (($level==$LOG_ERROR)){main::nxwrite (main::nxgetSTDERR (),($msg."\x0a"));}
return;}(my $logpackage=$package);($logpackage=~ s/^Common::// );if (defined (
$Logger::__no_log_packages{$logpackage})){if ((($level!=$LOG_ERROR)and ($level!=
$LOG_WARNING))){return;}}writeMessageToLog ($msg,$level,$storeInHistory,$sub);}
sub __multilineEntry{(my ($statusId,$level,$store,@msgs)=@_);if ((not (defined (
$statusId)))){warning (
"\x4c\x6f\x67\x67\x65\x72\x3a\x3a\x5f\x5f\x6d\x75\x6c\x74\x69\x6c\x69\x6e\x65\x45\x6e\x74\x72\x79\x20\x69\x6e\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x3a\x20\x75\x6e\x64\x65\x66\x69\x6e\x65\x64\x20\x73\x74\x61\x74\x75\x73\x49\x64\x2e"
);return;}if ((not (@msgs))){warning (
"\x4c\x6f\x67\x67\x65\x72\x3a\x3a\x5f\x5f\x6d\x75\x6c\x74\x69\x6c\x69\x6e\x65\x45\x6e\x74\x72\x79\x20\x69\x6e\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x3a\x20\x75\x6e\x64\x65\x66\x69\x6e\x65\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);return;}foreach my $line (@msgs){__log (((("\x3c".$statusId)."\x3e\x20").$line
),$level,$store);}}sub multilineLog{(my ($statusId,@msgs)=@_);__multilineEntry (
$statusId,$LOG_DEBUG,$__doNotStoreInHistory,@msgs);}sub multilineError{(my (
$statusId,@msgs)=@_);__multilineEntry ($statusId,$LOG_ERROR,$__storeInHistory,
@msgs);}sub isMessageDefined{(my $msg=shift (@_));if ((not (defined ($msg)))){
main::nxwrite (main::nxgetSTDERR (),
"\x4c\x6f\x67\x67\x65\x72\x3a\x3a\x6c\x6f\x67\x20\x69\x6e\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x63\x61\x6c\x6c\x2c\x20\x75\x6e\x64\x65\x66\x69\x6e\x65\x64\x20\x6d\x73\x67\x0a"
);main::nxexit ((0x1a00+ 2735-0x24af));}}sub isLevelDefined{(my $level=shift (@_
));if ((not (defined ($level)))){main::nxwrite (main::nxgetSTDERR (),
"\x4c\x6f\x67\x67\x65\x72\x3a\x3a\x6c\x6f\x67\x20\x69\x6e\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x63\x61\x6c\x6c\x2c\x20\x75\x6e\x64\x65\x66\x69\x6e\x65\x64\x20\x6c\x65\x76\x65\x6c\x0a"
);main::nxexit ((0x0f42+ 5519-0x24d0));}}sub isBacktraceDefined{(my ($backtrace,
$sub,$level)=@_);if ((not (defined ($backtrace)))){($sub=~ s/::__ANON__$/::Static/ )
;}return ($sub);}sub isDebugEnabled{return (($debugMode eq 
"\x65\x6e\x61\x62\x6c\x65"));}sub checkBacktrace{(my ($backtrace,$msg)=@_);
return;}sub setLoggerInfo{if ($GLOBAL::SessionLogLevel){($__level=
$GLOBAL::SessionLogLevel);}else{($__level=$LOG_INFO);}if ($GLOBAL::SOFTWARE_NAME
){($__whoami=$GLOBAL::SOFTWARE_NAME);}if (($GLOBAL::SessionLogLevel>
(0x006f+ 9892-0x270d))){($debugMode="\x65\x6e\x61\x62\x6c\x65");}}sub 
sendMessageToLogfile{(my ($msg,$level)=@_);(my $savedBytes=libnxh::NXLogWrite (
$msg));if (($savedBytes==(-(0x0344+ 2229-0x0bf8)))){(my $errorString=
libnxh::NXGetErrorString ());main::nxwrite (main::nxgetSTDERR (),((
"\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x6c\x6f\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$errorString)."\x27"));main::nxexit ((0x17fa+ 1661-0x1e76));}}sub __getLogLine{
(my $text=shift (@_));(my $timeline=Common::NXTime::getLoggerTimeline ());(my $pid
=$ $);
 (my $tid=$pid);(my $processName=sprintf ("\x25\x2d\x38\x73",$__whoami));
(my $message=((((((((($pid."\x20").$tid)."\x20").$timeline)."\x20").$processName
)."\x20").$text)."\x0a"));return ($message);}sub getFormattedLogLine{(my $text=
shift (@_));replaceSpecialCharacters ((\$text));return (__getLogLine ($text));}
sub setLogFile{(my $logfile=(""));($logfile=Common::NXPaths::getNXServerLogPath 
());if ((defined ($ENV{"\x4e\x58\x5f\x51\x55\x49\x43\x4b"})and ($ENV{
"\x4e\x58\x5f\x51\x55\x49\x43\x4b"}eq "\x31"))){(my $logDir=
Common::NXPaths::getSpecialUsersLogFolderPath ());if ((not (-d ($logDir)))){(my $returnValue
=libnxh::NXMakePath ($logDir,("")));debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x4d\x61\x6b\x65\x50\x61\x74\x68\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$returnValue)."\x27\x2e"));if (($returnValue!=(0x0939+ 6782-0x23b7))){(my $errorNumber
=libnxh::NXGetError ());(my $errorMessage=libnxh::NXGetErrorString ());error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x3a\x20"
.$logDir)."\x2e"));error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".
$errorNumber)."\x2c\x20\x27").$errorMessage)."\x27\x2e"));}}}return ($logfile);}
sub setMessageType{(my ($msg,$level)=@_);if (($level==$LOG_ERROR)){($msg=(
"\x45\x52\x52\x4f\x52\x21\x20".$msg));}elsif (($level==$LOG_WARNING)){($msg=(
"\x57\x41\x52\x4e\x49\x4e\x47\x21\x20".$msg));}return ($msg);}sub stackTrace{(my $backtrace
=Carp::longmess ($_));($backtrace=~ s/\n[\s]+/\n/ );(my (@lines)=split ( /\n/ ,
$backtrace,(0x07d5+ 3125-0x140a)));multilineLog (
"\x20\x53\x74\x61\x63\x6b\x74\x72\x61\x63\x65\x3a",@lines);return (());}sub 
logFilePath{return (Common::NXPaths::getNXServerLogPath ());}sub 
writeMessageToLog{(my ($msg,$level,$backtrace,$sub)=@_);($msg=prepareLogMessage 
($msg,$level));($sub=isBacktraceDefined ($backtrace,$sub,$level));($msg=
setMessageType ($msg,$level));if (((not (syslogEnabled ()))and __suppress ($msg,
$level))){return;}sendMessageToLogfile ($msg,$level);return;}sub 
prepareLogMessage{(my ($msg,$level)=@_);replaceSpecialCharacters ((\$msg));
hideAccessId ((\$msg));isMessageDefined ($msg);isLevelDefined ($level);if (
printProcessNamesToErrorsAndWarnings ()){if ((($level==$LOG_ERROR)or ($level==
$LOG_WARNING))){(my $nameString=(("\x50\x72\x6f\x63\x65\x73\x73\x20".
NXBegin::getProcessName ())."\x20\x72\x65\x70\x6f\x72\x74\x65\x64\x3a\x20"));(
$msg=($nameString.$msg));}}return ($msg);}sub replaceSpecialCharacters{(my $ref_message
=shift (@_));chomp ($$ref_message);($$ref_message=~ s/%/%%/g );($$ref_message=~ s/\n/\\n/g )
;}sub hideAccessId{(my $ref_message=shift (@_));($$ref_message=~ s/accessId=\d{9}/accessId=*********/gm )
;($$ref_message=~ s/accessid=\d{9}/accessid=*********/gm );($$ref_message=~ s/field=accessId,value=\d{9}/field=accessId,value=*********/gm )
;}sub storeInHistory{(my ($msg,$level)=@_);($msg=setMessageType ($msg,$level));
statusPush ($msg);}sub setLoggerNotWorking{($loggerWorking=(0x1181+ 1257-0x166a)
);}sub isLoggerWorking{return ($loggerWorking);}sub 
printProcessNamesToErrorsAndWarnings{return (
$flagPrintProcessNamesToErrorsAndWarnings);}sub debug{(my $message=shift (@_));(my $storeInHistory
=(shift (@_)||(0x097b+ 2852-0x149f)));__log ($message,$LOG_DEBUG,$storeInHistory
);}sub debug2{(my $message=shift (@_));(my $storeInHistory=(shift (@_)||
(0x00e4+ 6776-0x1b5c)));__log ($message,$LOG_DEBUG2,$storeInHistory);}sub debug3
{(my $message=shift (@_));(my $storeInHistory=(shift (@_)||(0x0f42+ 2840-0x1a5a)
));__log ($message,$LOG_DEBUG3,$storeInHistory);}sub info{(my $message=shift (@_
));(my $storeInHistory=(shift (@_)||(0x1612+ 3643-0x244d)));__log ($message,
$LOG_INFO,$storeInHistory);}sub notice{(my $message=shift (@_));(my $storeInHistory
=(shift (@_)||(0x18d8+ 1951-0x2077)));__log ($message,$LOG_NOTICE,
$storeInHistory);}sub warning{(my $message=shift (@_));(my $storeInHistory=(
shift (@_)||(0x18f2+ 2643-0x2345)));__log ($message,$LOG_WARNING,$storeInHistory
);}sub error{(my $message=shift (@_));(my $storeInHistory=(shift (@_)||
(0x06d5+ 4680-0x191d)));__log ($message,$LOG_ERROR,$storeInHistory);}sub 
connection{(my $message=shift (@_));(my $storeInHistory=(shift (@_)||
(0x0b14+ 5879-0x220b)));if (($GLOBAL::EnableConnectionLog==(0x0b30+ 3815-0x1a16)
)){__log ($message,$LOG_NOTICE,$storeInHistory);}else{__log ($message,$LOG_DEBUG
,$storeInHistory);}}sub getErrorLevel{return ($LOG_ERROR);}sub getInfoLevel{
return ($LOG_INFO);}sub getWarningLevel{return ($LOG_WARNING);}sub getDebugLevel
{return ($LOG_DEBUG);}sub getDebug2Level{return ($LOG_DEBUG2);}sub 
getDebug3Level{return ($LOG_DEBUG3);}sub getNoticeLevel{return ($LOG_NOTICE);}
sub isErrorLevel{(my $level=shift (@_));if (($level==$LOG_ERROR)){return (
(0x1f8f+ 485-0x2173));}else{return ((0x0704+ 5568-0x1cc4));}}sub isWarningLevel{
(my $level=shift (@_));if (($level==$LOG_WARNING)){return ((0x16df+ 2820-0x21e2)
);}else{return ((0x031d+ 9017-0x2656));}}sub isInfoLevel{(my $level=shift (@_));
if (($level==$LOG_INFO)){return ((0x02ba+ 5510-0x183f));}else{return (
(0x0baf+ 4755-0x1e42));}}sub isDebugLevel{(my $level=shift (@_));if (($level==
$LOG_DEBUG)){return ((0x06d8+ 4525-0x1884));}else{return ((0x1091+ 5270-0x2527))
;}}sub isDebug2Level{(my $level=shift (@_));if (($level==$LOG_DEBUG2)){return (
(0x0c52+ 1143-0x10c8));}else{return ((0x0c13+ 4071-0x1bfa));}}sub isDebug3Level{
(my $level=shift (@_));if (($level==$LOG_DEBUG3)){return ((0x0eb5+ 3397-0x1bf9))
;}else{return ((0x0c4a+ 3639-0x1a81));}}sub isNoticeLevel{(my $level=shift (@_))
;if (($level==$LOG_NOTICE)){return ((0x15d5+ 1372-0x1b30));}else{return (
(0x09a4+ 1794-0x10a6));}}sub syslogEnabled{if (($GLOBAL::EnableSyslogSupport eq 
"\x31")){return ((0x07fb+ 2732-0x12a6));}else{return ((0x0ef7+ 2663-0x195e));}}
sub __suppressStatusDump{(my $message=shift (@_));(my $level=$LOG_DEBUG);(my $statusMessage
=(0x027b+ 7404-0x1f66));return (__suppress ($message,$level,$statusMessage));}
sub __suppress{(my $msg=shift (@_));(my $level=shift (@_));(my $statusMessage=
shift (@_));if ((not (defined ($statusMessage)))){($statusMessage=
(0x09bb+ 5247-0x1e3a));}(my $ref_previousMessageCount=(\$__previousLogMessage));
(my $ref_previousMessage=(\$__previousLogMessageCount));if (($statusMessage==
(0x07b9+ 5152-0x1bd8))){($ref_previousMessage=(\$__previousStatusMessage));(
$ref_previousMessageCount=(\$__previousStatusMessageCount));}if ((not (
$$ref_previousMessage))){($$ref_previousMessage=$msg);(
$$ref_previousMessageCount=(0x0d86+ 6453-0x26ba));return ((0x00ec+ 684-0x0398));
}if (($$ref_previousMessage eq $msg)){($$ref_previousMessageCount=(
$$ref_previousMessageCount+(0x1ea9+ 1039-0x22b7)));return ((0x0726+ 6201-0x1f5e)
);}else{if (($$ref_previousMessageCount>(0x0f3d+ 2326-0x1852))){(my $count=(
$$ref_previousMessageCount-(0x1864+ 1312-0x1d83)));(my $message=(""));if ((
$count==(0x0812+ 2547-0x1204))){($message=((
"\x50\x72\x65\x76\x69\x6f\x75\x73\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x72\x65\x70\x65\x61\x74\x65\x64\x20"
.$count)."\x20\x74\x69\x6d\x65"));}else{($message=((
"\x50\x72\x65\x76\x69\x6f\x75\x73\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x72\x65\x70\x65\x61\x74\x65\x64\x20"
.$count)."\x20\x74\x69\x6d\x65\x73"));}if (($statusMessage==
(0x0996+ 1553-0x0fa6))){__statusPush ($message);}else{sendMessageToLogfile (
$message,$level);}($$ref_previousMessageCount=(0x04e0+ 5726-0x1b3d));}(
$$ref_previousMessage=$msg);return ((0x063b+ 4442-0x1795));}}sub 
getLogrotateLogTypeNxserverLog{return (
"\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67");}sub getLogrotateLogTypeNxdLog{
return ("\x64\x61\x65\x6d\x6f\x6e\x2e\x6c\x6f\x67");}sub 
getLogrotateLogTypeNwebclientLog{return (
"\x77\x65\x62\x72\x75\x6e\x6e\x65\x72\x2e\x6c\x6f\x67");}sub 
getLogrotateLogTypeNxhtdErrorLog{return ("\x68\x74\x64\x2e\x6c\x6f\x67");}sub 
getLogrotateLogTypeNxserviceLog{return (
"\x73\x65\x72\x76\x69\x63\x65\x2e\x6c\x6f\x67");}sub updateLogLevel{(my $newLevel
=shift (@_));if (($newLevel!=$__level)){($__level=$newLevel);info (((
"\x53\x65\x74\x20\x6e\x65\x77\x20\x6c\x6f\x67\x20\x6c\x65\x76\x65\x6c\x20\x27".
$newLevel)."\x27\x2e"));}else{debug (((
"\x4c\x6f\x67\x20\x6c\x65\x76\x65\x6c\x20\x27".$newLevel).
"\x27\x20\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x64\x2e"));}}return (
(0x0a49+ 7032-0x25c0));
