############################################################################
#                                                                          #
#  Copyright (c) 2001, 2025 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package Common::NXMsg;no warnings;($GLOBAL::Common::NXMsg::__inBuffer=(""));sub 
check_msg{(my $indexString=shift (@_));return (libnxh::NXCheckMsg ($indexString)
);}sub get_msg{(my $indexString=shift (@_));(my (@parameters)=@_);return (
libnxh::NXGetMessageWithList ($indexString,(\@parameters)));}sub send_response{(my $messageIndex
=shift (@_));(my (@parameters)=@_);libnxh::NXSendResponse ($messageIndex,(
\@parameters));}sub send_response_no_newline{(my $messageIndex=shift (@_));(my (
@parameters)=@_);libnxh::NXSendResponseNoNewLine ($messageIndex,(\@parameters));
}sub sendLogMessage{(my $message=shift (@_));(my $level=shift (@_));(my $storeInHistory
=shift (@_));if (Logger::isErrorLevel ($level)){Logger::error ($message,
$storeInHistory);}elsif (Logger::isWarningLevel ($level)){Logger::warning (
$message,$storeInHistory);}elsif (Logger::isInfoLevel ($level)){Logger::info (
$message,$storeInHistory);}else{Logger::debug ($message,$storeInHistory);}}sub 
fatal{(my $messageIndex=shift (@_));(my (@parameters)=@_);
libnxh::NXSendErrorMsgWithList ($messageIndex,(\@parameters));
NXShell::handle_command ("\x65\x78\x69\x74");}sub error{(my $index=shift (@_));(my (
@parameters)=@_);libnxh::NXSendErrorMsgWithList ($index,(\@parameters));}sub 
warning{(my $index=shift (@_));(my (@parameters)=@_);
libnxh::NXSendWarningMsgWithList ($index,(\@parameters));}sub info{(my $index=
shift (@_));(my (@parameters)=@_);libnxh::NXSendInfoMsgWithList ($index,(
\@parameters));}sub send_request{(my $pRegExp=shift (@_));(my $pMessage=shift (
@_));(my $value=shift (@_));(my (@parameters)=@_);(my $reg_exp=
libnxh::NXGetRegexp ($pRegExp));if (defined ($value)){if (($reg_exp eq 
"\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x63\x68\x61\x72")){if ((not (($value=~ /(^[^0-9A-Za-z_.+\-])$/ )
))){(my $tmp=$value);while (($tmp=~ s/(.)// )){if ((ord ($1)<
(0x08cd+ 4175-0x18fc))){Logger::error (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x5c"
.sprintf ("\x5c\x30\x25\x6f",ord ($1))).
"\x2e\x20\x4e\x6f\x6e\x20\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x75\x73\x65\x64\x20\x66\x6f\x72\x20\x74\x68\x69\x73\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72"
));return (());}}}}elsif ((not (($value=~ /$reg_exp/ )))){Logger::error (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x76\x61\x6c\x75\x65\x20\x27"
.$value)."\x27"));return (());}return ($value);}libnxh::NXSendRequest ($pRegExp,
(\@parameters));(my $data=__readnLine ());if ((not (defined ($data)))){return (
());}(my $log_data=$data);($log_data=~ s/(password=)([^&]*)/do {
        ($1 . ('*' x length($2)));
    };/eg )
;($log_data=~ s/(cookie=)([^&]*)/do {
        ($1 . ('*' x length($2)));
    };/eg )
;if (($pRegExp ne "\x63\x6f\x6d\x6d\x61\x6e\x64")){if ((($GLOBAL::PROTO_VERSION 
ne "\x73\x68\x65\x6c\x6c")and ($GLOBAL::PROTO_VERSION ne ("")))){main::nxwrite (
main::nxgetSTDOUT (),($data."\x0a"));}else{main::nxwrite (main::nxgetSTDOUT (),
"\x0a");}}Logger::debug (((
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x4d\x73\x67\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$log_data)."\x27"));(my $message=libnxh::NXGetMessageWithList ($pRegExp,(
\@parameters)));if (($reg_exp eq 
"\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x63\x68\x61\x72")){if ((not (($data=~ /(^[^0-9A-Za-z_.+\-])$/ )
))){(my $tmp=$data);while (($tmp=~ s/(.)// )){if ((ord ($1)<
(0x0a20+ 2884-0x1544))){Logger::error (((((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x74\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27\x3a\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x5c").sprintf (
"\x5c\x30\x25\x6f",ord ($1))).
"\x20\x69\x73\x20\x61\x20\x6e\x6f\x74\x20\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x75\x73\x65\x64\x20\x68\x65\x72\x65"
));return (());}}}}elsif ((not (($data=~ /$reg_exp/ )))){Logger::error (((((((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x74\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20"
.$message)."\x3a\x20").$log_data).
"\x20\x64\x6f\x65\x73\x6e\x27\x74\x20\x6d\x61\x74\x63\x68\x20\x77\x69\x74\x68\x20\x27"
).$reg_exp)."\x27"));main::nxwrite (main::nxgetSTDOUT (),"\x0a");return (());}if
 ((($data eq (""))and $GLOBAL::PROTO_VERSION)){main::nxwrite (main::nxgetSTDOUT 
(),"\x0a");}return ($data);}sub __readnLine{(my $maxLengt=(shift (@_)||
(0x2135+ 649-0x13be)));(my $data=());(my $endOfLine=(0x0582+ 1103-0x09d1));(my $ignoreUntileEOL
=(0x0b60+ 2769-0x1631));while ((not ($endOfLine))){(my $readBuff=());(my $bytesToRead
=($maxLengt-length ($GLOBAL::Common::NXMsg::__inBuffer)));if (($bytesToRead<=
(0x0866+ 5942-0x1f9c))){($GLOBAL::Common::NXMsg::__inBuffer=(""));(
$ignoreUntileEOL=(0x0183+ 4642-0x13a4));Logger::error (
"\x4e\x58\x4d\x73\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x6d\x6f\x72\x65\x20\x74\x68\x61\x6e\x20\x34\x30\x39\x36\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73"
);main::nxwrite (main::nxgetSTDOUT (),(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_ERROR_SERVING_REQUEST).
"\x20\x45\x52\x52\x4f\x52\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x6d\x6f\x72\x65\x20\x74\x68\x61\x6e\x20\x34\x30\x39\x36\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x3a\x20\x69\x67\x6e\x6f\x72\x69\x6e\x67\x20\x70\x72\x65\x76\x69\x6f\x75\x73\x20\x63\x6f\x6d\x6d\x61\x6e\x64"
));}(my $readBytes=main::nxread (main::nxgetSTDIN (),$readBuff,
(0x027b+ 8137-0x2243)));if ((not (defined ($readBytes)))){(my $errorstring=
libnxh::NXGetErrorString ());main::nxwrite (main::nxgetSTDOUT (),"\x0a");
NXShell::setExitRequest ((
"\x46\x61\x69\x6c\x65\x64\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x73\x74\x64\x69\x6e\x3a\x20"
.$errorstring));return (());}if (($readBytes==(0x2354+ 793-0x266d))){
main::nxwrite (main::nxgetSTDOUT (),"\x0a");NXShell::setExitRequest (
$ExitRequests::closedSTDIN);return (());}if (($readBuff eq "\x0a")){((
$ignoreUntileEOL eq (0x0a86+ 2007-0x125c))and ($ignoreUntileEOL=
(0x0cca+ 4077-0x1cb7)));($data=$GLOBAL::Common::NXMsg::__inBuffer);($endOfLine=
(0x13f6+ 1082-0x182f));($GLOBAL::Common::NXMsg::__inBuffer=(""));}else{if ((
$ignoreUntileEOL eq (0x18b7+ 1259-0x1da2))){($GLOBAL::Common::NXMsg::__inBuffer
.=$readBuff);}}}return ($data);}sub getBrandedMessage{(my $index=shift (@_));(my (
@parameters)=@_);(my $message=libnxh::NXGetEnglishMsgWithList ($index,(
\@parameters)));($message=~ s/\n/ /gm );return ($message);}sub checkIfAnswerIsNo
{(my $answer=shift (@_));return (libnxh::NXIfAnswerIsNo ($answer));}sub 
checkIfAnswerIsYes{(my $answer=shift (@_));return (libnxh::NXIfAnswerIsYes (
$answer));}sub getEnglishText{(my $index=shift (@_));(my (@parameters)=@_);
return (libnxh::NXGetEnglishMsgWithList ($index,(\@parameters)));}sub get_text{(my $index
=shift (@_));(my (@parameters)=@_);return (libnxh::NXGetTextWithList ($index,(
\@parameters)));}sub __shouldPackMessage{(my $index=shift (@_));if (
isErrorMessage ($index)){if (NXBegin::isModuletypeNxnode ()){return (
NXShell::shellModeStarted ());}elsif (NXBegin::isModuletypeNxserver ()){return (
Server::isClientSupportsPackedMessages ());}}return ((0x017b+ 9038-0x24c9));}sub
 packResponse{(my $indexString=shift (@_));(my $message=shift (@_));(my (
@parameters)=@_);(my $messageId=libnxh::NXGetMsgId ($indexString));(my $pack=
$messageId);($pack.=("\x2c".main::urlencode ($message)));foreach my $parameter (
@parameters){($pack.=("\x2c".main::urlencode ($parameter)));}return (((((
"\x4e\x58\x3e\x20".$GLOBAL::MSG_PACKED_RESPONSE)."\x20").$pack)."\x20"));}sub 
unpackResponse{(my $message=shift (@_));(my ($indexString,$rawMessage,
@parameters)=__unpackResponse ($message));return ($indexString,$rawMessage,
@parameters);}sub __unpackResponse{(my $message=shift (@_));(my $pack=(""));if (
($message=~ /NX> $GLOBAL::MSG_PACKED_RESPONSE (.*) / )){($pack=$1);}else{return 
((""),(0x0227+ 6015-0x19a6),(""),());}(my (@list)=split ( /,/ ,$pack,
(0x006a+ 6278-0x18f0)));(my $messageId=shift (@list));(my $rawMessage=shift (
@list));($rawMessage=main::urldecode ($rawMessage));(my $indexString=
libnxh::NXGetIndexString ($messageId));(my (@parameters)=());foreach my $parameter
 (@list){push (@parameters,main::urldecode ($parameter));}return ($indexString,
$rawMessage,@parameters);}sub isPackedMessage{(my $message=shift (@_));if ((
$message=~ /NX> (\d+)/ )){(my $number=$1);return (isPackedMessageNumber ($number
));}return ((0x0f1d+ 1875-0x1670));}sub isPackedMessageNumber{(my $number=shift 
(@_));if (($number==$GLOBAL::MSG_PACKED_RESPONSE)){return ((0x1b34+ 140-0x1bbf))
;}return ((0x111b+ 4798-0x23d9));}return ((0x1ded+ 1307-0x2307));
