############################################################################
#                                                                          #
#  Copyright (c) 2001, 2025 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXNetworkConfigurator;no warnings;($incorrectAccessIdCode=(-
(0x17a8+ 1814-0x1ebd)));($cancelOrErrorCode=(0x0373+ 2229-0x0c28));(
$acceptedCode=(0x114b+ 653-0x13d7));($askForNewAccessIdCode=(0x13f1+ 202-0x14b9)
);($askForNewMachineIdCode=(0x1a58+ 906-0x1ddf));($settingUsersAccessIdCode=
(0x0962+ 704-0x0c1e));($askForNewIdCode=(0x086d+ 7170-0x246a));(
$askForNewMasterIdCode=(0x0345+ 3546-0x1119));($askForNewSlaveIdCode=
(0x1017+ 3341-0x1d1d));sub addMachine{(my $interactive=shift (@_));(my $accessId
=shift (@_));(my $allowedToParse=shift (@_));(my $configDir=
Common::NXShellCreate::getCurrentUserConfigDir ());if ((not (
Common::NXFile::isExists ($configDir)))){
Common::NXShellCreate::createCurrentUserConfigDir ();}(my (%options)=());(my $accepted
=$settingUsersAccessIdCode);NXNetworkRedis::getOptions ((\%options));if (defined
 ($accessId)){($options{"\x61\x63\x63\x65\x73\x73\x49\x64"}=$accessId);}if (((
$options{"\x6d\x61\x63\x68\x69\x6e\x65\x43\x6f\x6f\x6b\x69\x65"}eq (""))and (
$options{"\x63\x6c\x75\x73\x74\x65\x72\x43\x6f\x6f\x6b\x69\x65"}eq ("")))){if ((
not (defined ($options{"\x61\x63\x63\x65\x73\x73\x49\x64"})))){($options{
"\x61\x63\x63\x65\x73\x73\x49\x64"}=__generateAccessId ());}($accepted=
$askForNewMachineIdCode);}if (($interactive==(0x0fd5+ 1451-0x1580))){if ((
__parseAllowed ((\%options),$allowedToParse)==$cancelOrErrorCode)){(my $errorReason
=NXMsg::get_text (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4e\x6f\x56\x61\x6c\x69\x64\x55\x73\x65\x72\x49\x64\x73"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);NXShell::setExitRequestCommandFinished ();return (
(0x1718+ 1486-0x1ce5));}}else{libnxh::NXSetCodeMessage (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x75\x73\x74\x65\x72\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,(0x098f+ 5246-0x1c19));libnxh::NXSetCodeMessage (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4d\x61\x63\x68\x69\x6e\x65\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,(0x0c80+ 2371-0x13cf));if (Server::isClusterSetUp ()){(my ($masterLimit,
$slaveLimit,$duration)=NXNetworkRedis::getTimeLimitParameters ());(my $hours=
Common::NXTime::convertSecondsToHoursRoundedUp ($duration));if ((($masterLimit 
ne (""))and ($slaveLimit ne ("")))){NXMsg::warning (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x75\x73\x74\x65\x72\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,$hours);}elsif (($masterLimit ne (""))){NXMsg::warning (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4d\x61\x63\x68\x69\x6e\x65\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,"\x4d\x61\x73\x74\x65\x72",$hours);}elsif (($slaveLimit ne (""))){
NXMsg::warning (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4d\x61\x63\x68\x69\x6e\x65\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,"\x53\x6c\x61\x76\x65",$hours);}}else{(my ($machineLimit,$duration)=
NXNetworkRedis::getTimeLimitParameters ());if (($machineLimit ne (""))){(my $hours
=Common::NXTime::convertSecondsToHoursRoundedUp ($duration));NXMsg::warning (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4d\x61\x63\x68\x69\x6e\x65\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,"\x4d\x61\x63\x68\x69\x6e\x65",$hours);}}libnxh::NXSetCodeMessage (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x75\x73\x74\x65\x72\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,(0x152d+ 3282-0x1ec6));libnxh::NXSetCodeMessage (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4d\x61\x63\x68\x69\x6e\x65\x49\x64\x57\x61\x73\x45\x64\x69\x74\x65\x64"
,(0x14fd+ 4827-0x249f));}if ((connectToNetwork (
"\x6e\x65\x74\x77\x6f\x72\x6b\x61\x64\x64")==(0x0460+ 7184-0x206f))){return (
(0x095c+ 1516-0x0f47));}(my (%changedClusterId)=());while (($accepted>
$acceptedCode)){if (($accepted==$askForNewMachineIdCode)){if ((not (
Server::isClusterSetUp ()))){($options{"\x72\x65\x71\x75\x65\x73\x74"}=
"\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64");}else{($options{
"\x72\x65\x71\x75\x65\x73\x74"}="\x43\x6c\x75\x73\x74\x65\x72\x20\x49\x64");(
$changedClusterId{"\x63\x6c\x75\x73\x74\x65\x72\x49\x64"}=(0x01fa+ 7107-0x1dbc))
;}if ((__getId ((\%options))==(0x1708+ 3003-0x22c2))){return (
(0x13eb+ 4614-0x25f0));}}elsif (($accepted==$askForNewMasterIdCode)){($options{
"\x72\x65\x71\x75\x65\x73\x74"}="\x4d\x61\x73\x74\x65\x72\x20\x49\x64");(
$changedClusterId{"\x6d\x61\x73\x74\x65\x72\x49\x64"}=(0x05ed+ 7545-0x2365));if 
((__getId ((\%options))==(0x17a5+ 3358-0x24c2))){return ((0x05aa+ 4930-0x18eb));
}}elsif (($accepted==$askForNewSlaveIdCode)){($options{
"\x72\x65\x71\x75\x65\x73\x74"}="\x53\x6c\x61\x76\x65\x20\x49\x64");(
$changedClusterId{"\x73\x6c\x61\x76\x65\x49\x64"}=(0x0eb1+ 4521-0x2059));if ((
__getId ((\%options))==(0x12e3+ 481-0x14c3))){return ((0x0ea2+ 3325-0x1b9e));}}
elsif (($accepted==$askForNewAccessIdCode)){($options{
"\x61\x63\x63\x65\x73\x73\x49\x64"}=__generateAccessId ());}if ((
__printAccessAndMachineID ((\%options))==(0x1933+ 458-0x1afc))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x6e\x65\x63\x74"
);return ((0x1d9c+  49-0x1dcc));}if (($interactive==(0x075d+ 2634-0x11a6))){(
$accepted=__handleClientInput ((\%options)));}else{($accepted=$acceptedCode);
last;}}if (($accepted==$incorrectAccessIdCode)){(my $errorReason=NXMsg::get_text
 (
"\x65\x47\x55\x49\x49\x6e\x76\x61\x6c\x69\x64\x46\x6f\x72\x6d\x61\x74\x41\x63\x63\x65\x73\x73\x49\x64"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);}if (($accepted!=$acceptedCode)){
NXShell::setExitRequestCommandFinished ();return ((0x1715+ 2920-0x227c));}if ((
$options{"\x72\x65\x71\x75\x65\x73\x74"}eq 
"\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64")){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x67\x69\x73\x74\x65\x72\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x69\x6e\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);if ((__registerMachine ((\%options))==(0x0cc1+ 4069-0x1ca5))){return (
(0x172a+ 2304-0x2029));}}elsif (($options{"\x72\x65\x71\x75\x65\x73\x74"}ne ("")
)){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x67\x69\x73\x74\x65\x72\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);if ((__registerCluster ((\%options),(\%changedClusterId))==
(0x0b63+ 947-0x0f15))){return ((0x1e5d+ 1766-0x2542));}}Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x53\x65\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x2e"
);if ((__setAccessId ($options{"\x61\x63\x63\x65\x73\x73\x49\x64"})==
(0x0996+ 725-0x0c6a))){return ((0x0c15+ 3905-0x1b55));}if ((__setAllowedUsers ((
\%options))==(0x1641+ 3806-0x251e))){return ((0x0229+ 4752-0x14b8));}if ((
setSharedOption ("\x79\x65\x73")==(0x068d+ 4983-0x1a03))){return (
(0x0881+ 7044-0x2404));}($options{"\x73\x74\x61\x74\x75\x73"}=
NXNetworkRedis::getStatusAdded ());NXNetworkRedis::setOptions ((\%options));
NXRedis::saveDb ();printVisibility ((\%options));return ((0x1b8f+ 2244-0x2453));
}sub removeMachine{if ((disconnectFromNetwork (
"\x6e\x65\x74\x77\x6f\x72\x6b\x64\x65\x6c")==(0x1fb4+  68-0x1ff7))){return (
(0x011a+ 7147-0x1d04));}NXNetworkRedis::removeMachine ();NXMsg::send_response (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x52\x65\x6d\x6f\x76\x65\x64");
return ((0x03a1+ 7447-0x20b8));}sub changeAccessId{(my $interactive=shift (@_));
(my $accessId=shift (@_));(my (%options)=());(my $accepted=$acceptedCode);if (((
not (defined ($accessId)))or ($accessId eq "\x72\x61\x6e\x64\x6f\x6d"))){(
$options{"\x61\x63\x63\x65\x73\x73\x49\x64"}=__generateAccessId ());}elsif ((not
 (NXNetworkTools::isAccessIdFormatCorrect ((\$accessId))))){(my $errorReason=
NXMsg::get_text (
"\x65\x47\x55\x49\x49\x6e\x76\x61\x6c\x69\x64\x46\x6f\x72\x6d\x61\x74\x41\x63\x63\x65\x73\x73\x49\x64"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);NXShell::setExitRequestCommandFinished ();return (
(0x08e7+ 5643-0x1ef1));}else{($options{"\x61\x63\x63\x65\x73\x73\x49\x64"}=
$accessId);}__printAccessId ($options{"\x61\x63\x63\x65\x73\x73\x49\x64"});if ((
$interactive==(0x08a4+ 4936-0x1beb))){($accepted=__handleClientInput ((\%options
)));}while (($accepted>$acceptedCode)){if (($accepted==$askForNewAccessIdCode)){
($options{"\x61\x63\x63\x65\x73\x73\x49\x64"}=__generateAccessId ());}
__printAccessId ($options{"\x61\x63\x63\x65\x73\x73\x49\x64"});($accepted=
__handleClientInput ((\%options)));}if (($accepted==$incorrectAccessIdCode)){(my $errorReason
=NXMsg::get_text (
"\x65\x47\x55\x49\x49\x6e\x76\x61\x6c\x69\x64\x46\x6f\x72\x6d\x61\x74\x41\x63\x63\x65\x73\x73\x49\x64"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);}if (($accepted!=$acceptedCode)){
NXShell::setExitRequestCommandFinished ();return ((0x0852+ 3568-0x1641));}if ((
__setAccessId ($options{"\x61\x63\x63\x65\x73\x73\x49\x64"})==
(0x08bd+ 4819-0x1b8f))){return ((0x000d+ 5487-0x157b));}
NXNetworkRedis::setAccessId ($options{"\x61\x63\x63\x65\x73\x73\x49\x64"});
NXRedis::saveDb ();NXMsg::send_response (
"\x69\x43\x4d\x44\x4e\x4d\x4e\x41\x63\x63\x65\x73\x73\x49\x64\x43\x68\x61\x6e\x67\x65\x64"
);return ((0x1752+ 3695-0x25c1));}sub changeMachineId{(my $interactive=shift (@_
));(my $machineId=shift (@_));(my $masterId=shift (@_));(my $slaveId=shift (@_))
;(my (%options)=());(my $edited=(""));(my $accepted=$cancelOrErrorCode);if (
defined ($machineId)){($edited="\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64");(
$accepted=$askForNewIdCode);}elsif ((defined ($masterId)and defined ($slaveId)))
{($edited="\x43\x6c\x75\x73\x74\x65\x72\x20\x49\x64");($accepted=
$askForNewIdCode);}elsif (defined ($masterId)){($edited=
"\x4d\x61\x73\x74\x65\x72\x20\x49\x64");($accepted=$askForNewMasterIdCode);}else
{($edited="\x53\x6c\x61\x76\x65\x20\x49\x64");($accepted=$askForNewSlaveIdCode);
}(my (%changedClusterId)=());while (($accepted>$acceptedCode)){if (($accepted==
$askForNewIdCode)){if (defined ($machineId)){($options{
"\x72\x65\x71\x75\x65\x73\x74"}="\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64");}
else{($options{"\x72\x65\x71\x75\x65\x73\x74"}=
"\x43\x6c\x75\x73\x74\x65\x72\x20\x49\x64");($changedClusterId{
"\x63\x6c\x75\x73\x74\x65\x72\x49\x64"}=(0x04a6+ 8162-0x2487));}}elsif ((
$accepted==$askForNewMasterIdCode)){($options{"\x72\x65\x71\x75\x65\x73\x74"}=
"\x4d\x61\x73\x74\x65\x72\x20\x49\x64");($changedClusterId{
"\x6d\x61\x73\x74\x65\x72\x49\x64"}=(0x04a9+ 3184-0x1118));}elsif (($accepted==
$askForNewSlaveIdCode)){($options{"\x72\x65\x71\x75\x65\x73\x74"}=
"\x53\x6c\x61\x76\x65\x20\x49\x64");($changedClusterId{
"\x73\x6c\x61\x76\x65\x49\x64"}=(0x16d9+ 268-0x17e4));}if ((__getId ((\%options)
)==(0x0c49+ 5371-0x2143))){return ((0x0475+ 7549-0x21f1));}__printMachineId ((
\%options));if (($interactive==(0x0a10+ 5808-0x20bf))){($accepted=
__handleClientInput ((\%options)));}else{($accepted=$acceptedCode);last;}}if ((
$accepted!=$acceptedCode)){NXShell::setExitRequestCommandFinished ();return (
(0x054d+ 4575-0x172b));}if (defined ($machineId)){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x67\x69\x73\x74\x65\x72\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x69\x6e\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);if ((__registerMachine ((\%options))==(0x0959+ 7596-0x2704))){return (
(0x059f+ 6999-0x20f5));}}else{Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x67\x69\x73\x74\x65\x72\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);if ((__registerCluster ((\%options),(\%changedClusterId))==
(0x1209+ 2873-0x1d41))){return ((0x0534+ 2849-0x1054));}}
NXNetworkRedis::setOptions ((\%options));NXRedis::saveDb ();NXMsg::send_response
 (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x45\x64\x69\x74\x65\x64"
,$edited);return ((0x0fa9+ 3690-0x1e13));}sub setSharedOption{(my $shared=shift 
(@_));($shared=Server::changeYesNoToInt ($shared));if ((__setShared ($shared)==
(0x06ac+ 8234-0x26d5))){return ((0x0b0d+ 2368-0x144c));}return (
(0x2393+  68-0x23d7));}sub setHostname{(my $hostname=shift (@_));if ((
__setHostname ($hostname)==(0x0713+ 475-0x08ed))){return ((0x0487+ 3027-0x1059))
;}main::nxrequire (
"\x4e\x58\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x69\x6f\x6e");
NXConfiguration::setKey ("\x6b\x65\x79",
"\x4e\x65\x74\x77\x6f\x72\x6b\x48\x6f\x73\x74\x4e\x61\x6d\x65",
"\x76\x61\x6c\x75\x65",$hostname);NXMsg::send_response (
"\x69\x43\x4d\x44\x4e\x4d\x4e\x48\x6f\x73\x74\x6e\x61\x6d\x65\x43\x68\x61\x6e\x67\x65\x64"
,Server::getAnywhereName (),$hostname);return ((0x0d6a+ 1505-0x134b));}sub 
printVisibility{(my $ref_options=shift (@_));(my $allowed=$$ref_options{
"\x61\x6c\x6c\x6f\x77\x65\x64"});if (((not (defined ($allowed)))or ($allowed eq 
("")))){($allowed=NXNetworkRedis::getAllowed ());}if (($allowed eq 
"\x6c\x69\x73\x74")){($allowed=$$ref_options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"});if (((not (defined (
$allowed)))or ($allowed eq ("")))){($allowed=NXNetworkRedis::getAllowedUsers ())
;}if (($allowed eq (""))){($allowed="\x65\x6d\x70\x74\x79\x20\x6c\x69\x73\x74");
}}NXMsg::send_response (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x56\x69\x73\x69\x62\x69\x6c\x69\x74\x79"
,$allowed);return ((0x20db+ 904-0x2463));}sub changeVisibility{(my $allowedToParse
=shift (@_));Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x43\x68\x61\x6e\x67\x69\x6e\x67\x20\x68\x6f\x73\x74\x20\x76\x69\x73\x69\x62\x69\x6c\x69\x74\x79\x20\x69\x6e\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);my (%options);if ((__parseAllowed ((\%options),$allowedToParse)==
$cancelOrErrorCode)){(my $errorReason=NXMsg::get_text (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4e\x6f\x56\x61\x6c\x69\x64\x55\x73\x65\x72\x49\x64\x73"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);NXShell::setExitRequestCommandFinished ();return (
(0x0fa4+ 3643-0x1dde));}if ((__setAllowedUsers ((\%options))==
(0x107d+ 3432-0x1de4))){return ((0x0c0b+ 281-0x0d23));}
NXNetworkRedis::setAllowed ($options{"\x61\x6c\x6c\x6f\x77\x65\x64"});if ((
defined ($options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"})and (
$options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}ne ("")))){
NXNetworkRedis::setAllowedUsers ($options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"});}NXRedis::saveDb ();
NXMsg::send_response ("\x69\x43\x4d\x44\x43\x68\x61\x6e\x67\x65\x64\x4e\x4d\x4e"
,Server::getAnywhereName ());return ((0x19b2+ 153-0x1a4b));}sub addVisibleUsers{
(my $allowedToParse=shift (@_));Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x41\x64\x64\x69\x6e\x67\x20\x75\x73\x65\x72\x73\x20\x74\x6f\x20\x76\x69\x73\x69\x62\x69\x6c\x69\x74\x79\x20\x6c\x69\x73\x74\x2e"
);my (%options);(my $usersInDb=NXNetworkRedis::getAllowedUsers ());if ((
__parseAllowed ((\%options),$allowedToParse,$usersInDb)==$cancelOrErrorCode)){(my $errorReason
=NXMsg::get_text (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4e\x6f\x56\x61\x6c\x69\x64\x55\x73\x65\x72\x49\x64\x73"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);NXShell::setExitRequestCommandFinished ();return (
(0x0986+ 851-0x0cd8));}if (($options{
"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"}ne (""))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x55\x73\x65\x72\x49\x73\x41\x6c\x72\x65\x61\x64\x79\x4f\x6e\x56\x69\x73\x69\x62\x6c\x65\x4c\x69\x73\x74"
,$options{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"});}if (($options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}eq (""))){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x54\x68\x65\x72\x65\x20\x61\x72\x65\x20\x6e\x6f\x20\x75\x73\x65\x72\x73\x20\x74\x6f\x20\x61\x64\x64\x2e"
);return ((0x0534+ 5471-0x1a93));}(my $usersToAdd=$options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"});if (($usersInDb ne (""))){(
$options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}.=("\x2c".$usersInDb
));}if ((__setAllowedUsers ((\%options))==(0x0058+ 1741-0x0724))){return (
(0x16b2+ 2062-0x1ebf));}NXNetworkRedis::setAllowedUsers ($options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"});NXMsg::send_response (
"\x69\x43\x4d\x44\x55\x73\x65\x72\x49\x73\x41\x64\x64\x65\x64\x54\x6f\x56\x69\x73\x69\x62\x6c\x65\x4c\x69\x73\x74"
,$usersToAdd);return ((0x1452+ 3942-0x23b8));}sub delVisibleUsers{(my $allowedToParse
=shift (@_));Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x44\x65\x6c\x65\x74\x69\x6e\x67\x20\x75\x73\x65\x72\x73\x20\x66\x72\x6f\x6d\x20\x76\x69\x73\x69\x62\x69\x6c\x69\x74\x79\x20\x6c\x69\x73\x74\x20\x69\x6e\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);my (%options);(my $allowedUsers=NXNetworkRedis::getAllowedUsers ());if ((
__parseAllowed ((\%options),$allowedToParse,$allowedUsers)==$cancelOrErrorCode))
{(my $errorReason=NXMsg::get_text (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4e\x6f\x56\x61\x6c\x69\x64\x55\x73\x65\x72\x49\x64\x73"
));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$errorReason);NXShell::setExitRequestCommandFinished ();return (
(0x09eb+ 4446-0x1b48));}if (($options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}ne (""))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x55\x73\x65\x72\x49\x73\x41\x6c\x72\x65\x61\x64\x79\x4e\x6f\x74\x45\x78\x69\x73\x74\x4f\x6e\x56\x69\x73\x69\x62\x6c\x65\x4c\x69\x73\x74"
,$options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"});}if (($options{
"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"}eq (""))){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x54\x68\x65\x72\x65\x20\x61\x72\x65\x20\x6e\x6f\x20\x75\x73\x65\x72\x73\x20\x74\x6f\x20\x64\x65\x6c\x2e"
);return ((0x04ef+ 2792-0x0fd7));}($options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}=__getAllowedUsersAfterDel (
$allowedUsers,$options{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"}));if 
(($options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}eq (""))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x4e\x6f\x74\x52\x65\x6d\x6f\x76\x65\x4c\x61\x73\x74\x56\x69\x73\x69\x62\x6c\x65\x55\x73\x65\x72"
,$options{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"});return (
(0x12a7+ 2927-0x1e15));}if ((__setAllowedUsers ((\%options))==
(0x05fd+ 6701-0x2029))){return ((0x035d+ 2922-0x0ec6));}
NXNetworkRedis::delAllowedUsers ($options{
"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"});NXMsg::send_response (
"\x69\x43\x4d\x44\x55\x73\x65\x72\x49\x73\x52\x65\x6d\x6f\x76\x65\x64\x46\x72\x6f\x6d\x56\x69\x73\x69\x62\x6c\x65\x4c\x69\x73\x74"
,$options{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"});return (
(0x116d+ 1127-0x15d4));}sub set2faOptions{(my $ref_parameters=shift (@_));if (((
$$ref_parameters{"\x65\x6e\x61\x62\x6c\x65\x64\x32\x66\x61"}ne "\x31")and (
$$ref_parameters{"\x74\x77\x6f\x66\x61\x63\x74\x6f\x72"}eq "\x6e\x6f"))){
Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x32\x46\x41\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e\x20\x4e\x6f\x20\x6e\x65\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);}else{if ((((($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65\x64\x32\x66\x61"}eq 
"\x31")and ($$ref_parameters{"\x74\x77\x6f\x66\x61\x63\x74\x6f\x72"}eq 
"\x79\x65\x73"))and ($$ref_parameters{
"\x75\x73\x65\x72\x43\x68\x61\x6e\x67\x65\x64"}==(0x058c+ 4143-0x15bb)))and (
$$ref_parameters{"\x6e\x6f\x74\x69\x66\x79\x43\x68\x61\x6e\x67\x65\x64"}==
(0x0526+ 7508-0x227a)))){Logger::warning (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x32\x46\x41\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x65\x6e\x61\x62\x6c\x65\x64\x20\x61\x6e\x64\x20\x6e\x6f\x20\x6f\x70\x74\x69\x6f\x6e\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x63\x68\x61\x6e\x67\x65\x64\x2e"
);}else{Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x32\x46\x41\x20\x6f\x70\x74\x69\x6f\x6e\x73\x20\x69\x6e\x20\x4e\x65\x74\x77\x6f\x72\x6b\x2e"
);if ((__set2faOptions ($ref_parameters)==(0x10c3+ 1994-0x188c))){return (
(0x0dfb+ 1168-0x128a));}}}(my $status=(""));(my (%optionsToDb)=());if ((
$$ref_parameters{"\x74\x77\x6f\x66\x61\x63\x74\x6f\x72"}eq "\x79\x65\x73")){(
$status="\x65\x6e\x61\x62\x6c\x65\x64");($optionsToDb{
"\x65\x6e\x61\x62\x6c\x65\x64\x32\x66\x61"}=(0x0fbb+ 2301-0x18b7));if ((
$$ref_parameters{"\x75\x73\x65\x72\x43\x68\x61\x6e\x67\x65\x64"}==
(0x17d7+ 3810-0x26b8))){($optionsToDb{"\x75\x73\x65\x72"}=$$ref_parameters{
"\x75\x73\x65\x72"});}if (($$ref_parameters{
"\x6e\x6f\x74\x69\x66\x79\x43\x68\x61\x6e\x67\x65\x64"}==(0x0e54+ 4821-0x2128)))
{($optionsToDb{"\x6e\x6f\x74\x69\x66\x79"}=$$ref_parameters{
"\x6e\x6f\x74\x69\x66\x79"});}NXNetworkRedis::set2fa ((\%optionsToDb));}else{(
$status="\x64\x69\x73\x61\x62\x6c\x65\x64");if (($$ref_parameters{
"\x72\x65\x73\x65\x74"}==(0x06ab+ 1713-0x0d5b))){NXNetworkRedis::del2fa ();}else
{NXNetworkRedis::delCookie2fa ();}}NXMsg::send_response (
"\x69\x43\x4d\x44\x32\x66\x61\x53\x74\x61\x74\x75\x73\x49\x73",$status);if (((
$$ref_parameters{"\x72\x65\x73\x65\x74"}==(0x0e24+ 4439-0x1f7a))and (
$$ref_parameters{"\x75\x73\x65\x72"}ne ("")))){NXMsg::send_response (
"\x69\x43\x4d\x44\x32\x66\x61\x55\x73\x65\x72\x52\x65\x6d\x6f\x76\x65\x64",
$$ref_parameters{"\x75\x73\x65\x72"});}else{if (($$ref_parameters{
"\x75\x73\x65\x72"}eq (""))){($$ref_parameters{"\x75\x73\x65\x72"}=
"\x6e\x6f\x6e\x65");}NXMsg::send_response (
"\x69\x43\x4d\x44\x32\x66\x61\x55\x73\x65\x72\x49\x73",$$ref_parameters{
"\x75\x73\x65\x72"});}(my $notify="\x64\x69\x73\x61\x62\x6c\x65\x64");if (((
$$ref_parameters{"\x72\x65\x73\x65\x74"}==(0x03aa+ 3732-0x123e))and (
$$ref_parameters{"\x6e\x6f\x74\x69\x66\x79"}eq "\x79\x65\x73"))){($notify=
"\x65\x6e\x61\x62\x6c\x65\x64");}NXMsg::send_response (
"\x69\x43\x4d\x44\x32\x66\x61\x4e\x6f\x74\x69\x66\x79\x41\x74\x74\x65\x6d\x70\x74\x73\x41\x72\x65"
,$notify);if ((($$ref_parameters{"\x74\x77\x6f\x66\x61\x63\x74\x6f\x72"}eq 
"\x79\x65\x73")and ($$ref_parameters{
"\x75\x73\x65\x72\x43\x68\x61\x6e\x67\x65\x64"}==(0x02c8+ 4473-0x1440)))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x32\x66\x61\x49\x6e\x66\x6f\x41\x62\x6f\x75\x74\x55\x73\x65\x72\x41\x63\x63\x6f\x75\x6e\x74"
);}return ((0x0a1f+ 3429-0x1784));}sub resetMachineProtection{(my $error=(""));
main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForResetMachineProtection ((\$error));if (($error ne
 (""))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x50\x72\x6f\x74\x65\x63\x74\x69\x6f\x6e\x52\x65\x73\x65\x74\x45\x72\x72\x6f\x72"
,$error);NXShell::setExitRequestCommandFinished ();return ((0x0f0d+ 6076-0x26c8)
);}NXMsg::send_response (
"\x69\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x50\x72\x6f\x74\x65\x63\x74\x69\x6f\x6e\x52\x65\x73\x65\x74"
);return ((0x016c+ 2863-0x0c9b));}sub __isUserOnList{(my $userToCheck=shift (@_)
);(my $allowedUsers=shift (@_));(my (@allowedUsers)=split ( /,/ ,$allowedUsers,
(0x1f43+ 719-0x2212)));foreach my $user (@allowedUsers){($user=main::urldecode (
$user));if ((lc ($user)eq lc ($userToCheck))){Logger::debug (((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x55\x73\x65\x72\x20\x27"
.$userToCheck).
"\x27\x20\x69\x73\x20\x6f\x6e\x20\x61\x6c\x6c\x6f\x77\x6c\x69\x73\x74\x2e"));
return ((0x091f+ 1343-0x0e5d));}}Logger::debug (((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x55\x73\x65\x72\x20\x27"
.$userToCheck).
"\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x6f\x6e\x20\x61\x6c\x6c\x6f\x77\x6c\x69\x73\x74\x2e"
));return ((0x1d1f+  18-0x1d31));}sub __printAccessAndMachineID{(my $ref_options
=shift (@_));(my $accessId=$$ref_options{"\x61\x63\x63\x65\x73\x73\x49\x64"});if
 (($accessId eq (""))){($accessId="\x6e\x6f\x74\x20\x73\x65\x74");}my ($buffer);
if (($$ref_options{"\x6d\x61\x73\x74\x65\x72\x49\x64"}ne (""))){($buffer.=((((
"\x4e\x58\x3e\x20".$GLOBAL::MSG_NETWORK).
"\x20\x4d\x61\x73\x74\x65\x72\x20\x49\x64\x3a\x20").$$ref_options{
"\x6d\x61\x73\x74\x65\x72\x49\x64"})."\x0a"));($buffer.=(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_NETWORK)."\x20\x53\x6c\x61\x76\x65\x20\x49\x64\x3a\x20").
$$ref_options{"\x73\x6c\x61\x76\x65\x49\x64"})."\x0a"));($buffer.=((((
"\x4e\x58\x3e\x20".$GLOBAL::MSG_NETWORK).
"\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x3a\x20"
).$accessId)."\x0a"));}else{($buffer.=(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_NETWORK)."\x20\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64\x3a\x20").
$$ref_options{"\x6d\x61\x63\x68\x69\x6e\x65\x49\x64"})."\x0a"));($buffer.=((((
"\x4e\x58\x3e\x20".$GLOBAL::MSG_NETWORK).
"\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x3a\x20").$accessId)."\x0a"));}if ((
main::nxwrite (main::nxgetSTDOUT (),$buffer)==(-(0x0c21+ 1603-0x1263)))){return 
((0x1f2a+ 1999-0x26f8));}Logger::replaceSpecialCharacters ((\$buffer));
Logger::debug (((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x57\x72\x6f\x74\x65\x20\x27"
.$buffer)."\x27\x2e"));return ((0x0a0a+ 3394-0x174c));}sub __printAccessId{(my $accessId
=shift (@_));if ((not (defined ($accessId)))){($accessId=
NXNetworkRedis::getAccessId ());}if (($accessId eq (""))){($accessId=
"\x6e\x6f\x74\x20\x73\x65\x74");}if (NXLicense::isClusterCreateFeature ()){if ((
main::nxwrite (main::nxgetSTDOUT (),(((("\x4e\x58\x3e\x20".$GLOBAL::MSG_NETWORK)
.
"\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x3a\x20"
).$accessId)."\x0a"))==(-(0x04c8+ 7309-0x2154)))){return ((0x02e8+ 5505-0x1868))
;}}else{if ((main::nxwrite (main::nxgetSTDOUT (),(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_NETWORK)."\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x3a\x20").
$accessId)."\x0a"))==(-(0x0de9+ 2127-0x1637)))){return ((0x1ab1+ 2169-0x2329));}
}return ((0x1d6b+ 1037-0x2178));}sub __answer{(my $fd=shift (@_));(my $msg=shift
 (@_));if ((main::nxwrite ($fd,$msg)==(-(0x063d+ 3672-0x1494)))){Logger::warning
 (((((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x27"
.$msg)."\x27\x20\x6f\x6e\x20\x46\x44\x23").$fd)."\x2e"));return (
(0x06c2+ 2587-0x10dc));}Logger::replaceSpecialCharacters ((\$msg));Logger::debug
 (((((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x53\x65\x6e\x64\x20\x27"
.$msg)."\x27\x20\x6f\x6e\x20\x46\x44\x23").$fd)."\x2e"));return (
(0x10f1+ 1460-0x16a5));}sub __printMachineId{(my $ref_options=shift (@_));(my $msg
=(""));if (($$ref_options{"\x6d\x61\x63\x68\x69\x6e\x65\x49\x64"}ne (""))){($msg
=(((("\x4e\x58\x3e\x20".$GLOBAL::MSG_NETWORK).
"\x20\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64\x3a\x20").$$ref_options{
"\x6d\x61\x63\x68\x69\x6e\x65\x49\x64"})."\x0a"));return (__answer (
main::nxgetSTDOUT (),$msg));}if (($$ref_options{
"\x6d\x61\x73\x74\x65\x72\x49\x64"}ne (""))){($msg.=(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_NETWORK)."\x20\x4d\x61\x73\x74\x65\x72\x20\x49\x64\x3a\x20").
$$ref_options{"\x6d\x61\x73\x74\x65\x72\x49\x64"})."\x0a"));}if (($$ref_options{
"\x73\x6c\x61\x76\x65\x49\x64"}ne (""))){($msg.=(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_NETWORK)."\x20\x53\x6c\x61\x76\x65\x20\x49\x64\x3a\x20").
$$ref_options{"\x73\x6c\x61\x76\x65\x49\x64"})."\x0a"));}return (__answer (
main::nxgetSTDOUT (),$msg));}sub __parseAllowed{(my $ref_options=shift (@_));(my $lineToParse
=shift (@_));(my $allowedUsers=shift (@_));Logger::debug (((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x50\x61\x72\x73\x69\x6e\x67\x20\x61\x6c\x6c\x6f\x77\x65\x64\x3a\x20"
.$lineToParse)."\x2e"));if ((($lineToParse=~ /^all$/ )or ($lineToParse=~ /^nobody$/ )
)){($$ref_options{"\x61\x6c\x6c\x6f\x77\x65\x64"}=$lineToParse);}else{(
$$ref_options{"\x61\x6c\x6c\x6f\x77\x65\x64"}="\x6c\x69\x73\x74");return (
__parseAllowedList ($ref_options,$lineToParse,$allowedUsers));}return (
$acceptedCode);}sub __parseAllowedList{(my $ref_options=shift (@_));(my $lineToParse
=shift (@_));(my $allowedUsers=shift (@_));Logger::debug (((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x50\x61\x72\x73\x69\x6e\x67\x20\x61\x6c\x6c\x6f\x77\x65\x64\x20\x6c\x69\x73\x74\x3a\x20"
.$lineToParse)."\x2e"));($lineToParse=~ s/, /,/ );($lineToParse=~ s/ /,/ );(my (
@users)=split ( /,/ ,$lineToParse,(0x074b+ 1479-0x0d12)));(my (%checked)=());
foreach my $user (@users){unless (($checked{lc ($user)}++)){if ((not (
NXNetworkTools::isUserIdFormatCorrect ($user)))){($$ref_options{
"\x69\x6e\x76\x61\x6c\x69\x64\x55\x73\x65\x72\x73"}.=($user."\x2c"));}elsif ((
defined ($allowedUsers)and __isUserOnList ($user,$allowedUsers))){($$ref_options
{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"}.=($user."\x2c"));}else{(
$$ref_options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}.=($user."\x2c"
));}}}($$ref_options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}=~ s/,$// )
;($$ref_options{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"}=~ s/,$// );(
$$ref_options{"\x69\x6e\x76\x61\x6c\x69\x64\x55\x73\x65\x72\x73"}=~ s/,$// );
Logger::debug ((((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x46\x69\x6e\x69\x73\x68\x65\x64\x20\x70\x61\x72\x73\x69\x6e\x67\x20\x61\x6c\x6c\x6f\x77\x20\x6c\x69\x73\x74\x2e\x20"
.(("\x41\x6c\x6c\x6f\x77\x65\x64\x20\x75\x73\x65\x72\x73\x3a\x20".$$ref_options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"})."\x2c\x20")).((
"\x63\x75\x72\x72\x65\x6e\x74\x20\x75\x73\x65\x72\x73\x3a\x20".$$ref_options{
"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"})."\x2c\x20")).((
"\x69\x6e\x76\x61\x6c\x69\x64\x20\x75\x73\x65\x72\x73\x3a\x20".$$ref_options{
"\x69\x6e\x76\x61\x6c\x69\x64\x55\x73\x65\x72\x73"})."\x2e")));if (((
$$ref_options{"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}eq (""))and (
$$ref_options{"\x63\x75\x72\x72\x65\x6e\x74\x55\x73\x65\x72\x73"}eq ("")))){
return ($cancelOrErrorCode);}if (($$ref_options{
"\x69\x6e\x76\x61\x6c\x69\x64\x55\x73\x65\x72\x73"}ne (""))){
NXMsg::send_response (
"\x77\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x57\x72\x6f\x6e\x67\x55\x73\x65\x72\x49\x64"
,$$ref_options{"\x69\x6e\x76\x61\x6c\x69\x64\x55\x73\x65\x72\x73"});}return (
$acceptedCode);}sub __getAllowedUsersAfterDel{(my $currentUsers=shift (@_));(my $usersToDel
=shift (@_));(my $allowed=(""));foreach my $user (split ( /,/ ,$currentUsers,
(0x0da8+ 6408-0x26b0))){if ((not (__isUserOnList ($user,$usersToDel)))){(
$allowed.=($user."\x2c"));}}($allowed=~ s/,$// );return ($allowed);}sub 
__handleClientInput{(my $ref_options=shift (@_));(my $readline=
(0x03b6+ 6237-0x1c13));while (($readline==(0x137f+ 374-0x14f5))){my ($reply);
Common::NXCore::readInputTillNewline (main::nxgetSTDIN (),(\$reply));($reply=
main::trimLine ($reply));Logger::debug (((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x48\x61\x6e\x64\x6c\x65\x20\x63\x6c\x69\x65\x6e\x74\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$reply)."\x27\x2e"));if (($reply=~ /^visible-set=(.*)/ )){return (
__parseAllowed ($ref_options,$1));}elsif (($reply=~ /accessid=(.*)/ )){
Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x65\x77\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x2e"
);(my $accessId=$1);if (NXNetworkTools::isAccessIdFormatCorrect ((\$accessId))){
($$ref_options{"\x61\x63\x63\x65\x73\x73\x49\x64"}=$accessId);return (
$settingUsersAccessIdCode);}Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x57\x72\x6f\x6e\x67\x20\x66\x6f\x72\x6d\x61\x74\x20\x6f\x66\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x2e"
);return ($incorrectAccessIdCode);}elsif (($reply eq 
"\x6e\x65\x77\x61\x63\x63\x65\x73\x73\x69\x64")){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6e\x65\x77\x20\x41\x63\x63\x65\x73\x73\x20\x49\x64\x2e"
);return ($askForNewAccessIdCode);}elsif (($reply eq 
"\x6e\x65\x77\x6d\x61\x63\x68\x69\x6e\x65\x69\x64")){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6e\x65\x77\x20\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64\x2e"
);return ($askForNewMachineIdCode);}elsif (($reply eq 
"\x6e\x65\x77\x6d\x61\x73\x74\x65\x72\x69\x64")){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6e\x65\x77\x20\x4d\x61\x73\x74\x65\x72\x20\x49\x64\x2e"
);return ($askForNewMasterIdCode);}elsif (($reply eq 
"\x6e\x65\x77\x73\x6c\x61\x76\x65\x69\x64")){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x52\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6e\x65\x77\x20\x53\x6c\x61\x76\x65\x20\x49\x64\x2e"
);return ($askForNewSlaveIdCode);}elsif (($reply eq "\x61\x63\x63\x65\x70\x74"))
{Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x41\x63\x63\x65\x70\x74\x65\x64\x20\x49\x64\x2e"
);return ($acceptedCode);}elsif (($reply eq "\x03")){Logger::debug (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x43\x61\x6e\x63\x65\x6c\x20\x72\x65\x71\x75\x65\x73\x74\x2e"
);return ($cancelOrErrorCode);}elsif (($reply eq "\x62\x79\x65")){Logger::debug 
(
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x45\x78\x69\x74\x20\x72\x65\x71\x75\x65\x73\x74\x2e"
);return ($cancelOrErrorCode);}}return ($cancelOrErrorCode);}sub 
convertTimeParameters{(my $ref_duration=shift (@_));(my $ref_nextAttempt=shift (
@_));Logger::debug ((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x54\x68\x65\x20\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64\x20\x63\x61\x6e\x20\x6f\x6e\x6c\x79\x20\x62\x65\x20\x63\x68\x61\x6e\x67\x65\x64\x20"
.(("\x6f\x6e\x63\x65\x20\x65\x76\x65\x72\x79\x20".$$ref_duration).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e")));($$ref_duration=
Common::NXTime::convertSecondsToHoursRoundedUp ($$ref_duration));(my $secsToNextAttempt
=($$ref_nextAttempt-Common::NXTime::getSecondsSinceEpoch ()));Logger::debug ((
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x54\x68\x65\x20\x6e\x65\x78\x74\x20\x61\x74\x74\x65\x6d\x70\x74\x20\x63\x61\x6e\x20\x62\x65\x20\x6d\x61\x64\x65\x20\x61\x74\x20"
.((($$ref_nextAttempt."\x20\x2d\x20\x61\x66\x74\x65\x72\x20").$secsToNextAttempt
)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e")));($$ref_nextAttempt=
Common::NXTime::convertSecondsToHoursRoundedUp ($secsToNextAttempt));if ((
$$ref_nextAttempt>$$ref_duration)){($$ref_nextAttempt=$$ref_duration);}}sub 
__generateAccessId{(my $numberOfDigits=(0x23e4+ 611-0x263e));(my $generateKey=(
libnxh::NXGetRandomNumber ()%((0x14ff+  72-0x153d)**$numberOfDigits)));(my $len=
length ($generateKey));if (($len<$numberOfDigits)){($generateKey=(("\x30" x (
$numberOfDigits-$len)).$generateKey));}return ($generateKey);}sub 
isNetworkConnected{(my $status=__askForConnectionStatus ());if (($status eq 
"\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64")){return ((0x0d6d+ 2122-0x15b6));}return 
((0x044f+ 8246-0x2485));}sub connectToNetwork{(my $commandInvoked=(shift (@_)||
("")));(my $error=(""));main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForConnectToNetwork ((\$error),$commandInvoked);if (
($error ne (""))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x68\x61\x6e\x67\x65\x4e\x65\x74\x77\x6f\x72\x6b\x41\x76\x61\x69\x6c\x61\x62\x69\x6c\x69\x74\x79"
,$error);NXShell::setExitRequestCommandFinished ();return ((0x1d8c+ 986-0x2165))
;}return ((0x1732+ 1335-0x1c69));}sub disconnectFromNetwork{(my $commandInvoked=
(shift (@_)||("")));(my $error=(""));main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForDisconnectFromNetwork ((\$error),$commandInvoked)
;if (($error ne (""))){if ((($error ne NXMsg::get_text (
"\x65\x47\x55\x49\x53\x65\x72\x76\x65\x72\x49\x73\x4e\x6f\x74\x52\x75\x6e\x6e\x69\x6e\x67"
))and ($commandInvoked eq "\x6e\x65\x74\x77\x6f\x72\x6b\x64\x65\x6c"))){
Logger::warning (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x6f\x72\x3a\x20\x50\x72\x6f\x62\x6c\x65\x6d\x20\x77\x69\x74\x68\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6e\x67\x20\x74\x6f\x20\x4e\x65\x74\x77\x6f\x72\x6b\x20\x64\x75\x72\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27\x6e\x65\x74\x77\x6f\x72\x6b\x64\x65\x6c\x27\x2e"
);}else{NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x68\x61\x6e\x67\x65\x4e\x65\x74\x77\x6f\x72\x6b\x41\x76\x61\x69\x6c\x61\x62\x69\x6c\x69\x74\x79"
,$error);NXShell::setExitRequestCommandFinished ();return ((0x0ae9+ 2408-0x1450)
);}}return ((0x1ef7+ 1434-0x2491));}sub __getId{(my $ref_options=shift (@_));(my $error
=(""));main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);if (($$ref_options{"\x72\x65\x71\x75\x65\x73\x74"}eq 
"\x4d\x61\x63\x68\x69\x6e\x65\x20\x49\x64")){
NXNetworkClientDaemon::askForMachineId ($ref_options,(\$error));}else{
NXNetworkClientDaemon::askForClusterId ($ref_options,(\$error));}if (($error ne 
(""))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$error);NXShell::setExitRequestCommandFinished ();return ((0x0816+ 3811-0x16f8)
);}return ((0x0573+ 2731-0x101e));}sub __registerMachine{(my $ref_options=shift 
(@_));(my $error=(""));main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForRegisterMachine ($ref_options,(\$error));if ((
$error eq (""))){return ((0x1cc3+ 415-0x1e62));}elsif (($error=~ /Editing Id locked: nextAttempt=(.*), limitDuration=(.*)./ )
){(my $nextAttempt=$1);(my $duration=$2);convertTimeParameters ((\$duration),(
\$nextAttempt));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x45\x64\x69\x74\x4d\x61\x63\x68\x69\x6e\x65\x49\x64"
,"\x4d\x61\x63\x68\x69\x6e\x65",$duration,$nextAttempt);}else{NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$error);}NXShell::setExitRequestCommandFinished ();return ((0x1701+ 984-0x1ad8)
);}sub __registerCluster{(my $ref_options=shift (@_));(my $ref_clusterId=shift (
@_));(my $error=(""));(my $askedId=(""));main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);if ((defined ($$ref_clusterId{"\x63\x6c\x75\x73\x74\x65\x72\x49\x64"})and (
$$ref_clusterId{"\x63\x6c\x75\x73\x74\x65\x72\x49\x64"}==(0x0181+ 477-0x035d))))
{($askedId="\x63\x6c\x75\x73\x74\x65\x72");
NXNetworkClientDaemon::askForRegisterCluster ($ref_options,(\$error),$askedId);}
else{if ((defined ($$ref_clusterId{"\x6d\x61\x73\x74\x65\x72\x49\x64"})and (
$$ref_clusterId{"\x6d\x61\x73\x74\x65\x72\x49\x64"}==(0x0489+  53-0x04bd)))){(
$askedId="\x6d\x61\x73\x74\x65\x72");
NXNetworkClientDaemon::askForRegisterCluster ($ref_options,(\$error),$askedId);}
if (((($error eq (""))and defined ($$ref_clusterId{
"\x73\x6c\x61\x76\x65\x49\x64"}))and ($$ref_clusterId{
"\x73\x6c\x61\x76\x65\x49\x64"}==(0x0073+ 4807-0x1339)))){($askedId=
"\x73\x6c\x61\x76\x65");NXNetworkClientDaemon::askForRegisterCluster (
$ref_options,(\$error),$askedId);}}if (($error eq (""))){return (
(0x1090+ 3358-0x1dae));}elsif (($error=~ /Editing Id locked: nextAttempt=(.*), limitDuration=(.*)./ )
){(my $nextAttempt=$1);(my $duration=$2);convertTimeParameters ((\$duration),(
\$nextAttempt));($askedId=ucfirst ($askedId));NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x45\x64\x69\x74\x4d\x61\x63\x68\x69\x6e\x65\x49\x64"
,$askedId,$duration,$nextAttempt);}else{NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x65"
,$error);}NXShell::setExitRequestCommandFinished ();return (
(0x095c+ 4756-0x1bef));}sub __setAccessId{(my $accessId=shift (@_));(my $error=
(""));(my $option=("\x61\x63\x63\x65\x73\x73\x49\x64\x3d".$accessId));
main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForSetOptions ($option,(\$error));if (($error ne 
(""))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x6e\x65\x63\x74"
);NXShell::setExitRequestCommandFinished ();return ((0x1397+ 3720-0x221e));}
return ((0x17c8+ 599-0x1a1f));}sub __setAllowedUsers{(my $ref_options=shift (@_)
);(my $error=(""));(my $params=("\x61\x6c\x6c\x6f\x77\x65\x64\x3d".$$ref_options
{"\x61\x6c\x6c\x6f\x77\x65\x64"}));if (($$ref_options{
"\x61\x6c\x6c\x6f\x77\x65\x64"}eq "\x6c\x69\x73\x74")){($params.=(
"\x2c\x20\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73\x3d".$$ref_options{
"\x61\x6c\x6c\x6f\x77\x65\x64\x55\x73\x65\x72\x73"}));}main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForSetOptions ($params,(\$error));if (($error ne 
(""))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x6e\x65\x63\x74"
);NXShell::setExitRequestCommandFinished ();return ((0x0ff3+ 881-0x1363));}
return ((0x0349+ 2423-0x0cc0));}sub __setHostname{(my $hostname=shift (@_));(my $error
=(""));(my $option=("\x68\x6f\x73\x74\x6e\x61\x6d\x65\x3d".$hostname));
main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForSetOptions ($option,(\$error));if (($error ne 
(""))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x6e\x65\x63\x74"
);NXShell::setExitRequestCommandFinished ();return ((0x010b+ 4360-0x1212));}
return ((0x1cd5+ 2023-0x24bc));}sub __setShared{(my $shared=shift (@_));(my $error
=(""));(my $option=("\x73\x68\x61\x72\x65\x64\x3d".$shared));main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForSetOptions ($option,(\$error));if (($error ne 
(""))){NXMsg::error (
"\x65\x43\x4d\x44\x4e\x65\x74\x77\x6f\x72\x6b\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x6e\x65\x63\x74"
);NXShell::setExitRequestCommandFinished ();return ((0x07df+ 1663-0x0e5d));}
return ((0x0d1b+ 1034-0x1125));}sub __askForConnectionStatus{(my $status=
"\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");main::nxrequire (
"\x4e\x58\x43\x6c\x69\x65\x6e\x74\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73"
);(my $reply=NXClientSystemDaemons::askServerDaemonNetworkStatus ());if (($reply
=~ /NX> $GLOBAL::MSG_NETWORK_STATUS Network connection status is: (.*)./ )){(
$status=$1);}return ($status);}sub __set2faOptions{(my $ref_parameters=shift (@_
));(my $error=(""));(my $options=(("\x74\x77\x6f\x66\x61\x63\x74\x6f\x72\x3d".
$$ref_parameters{"\x74\x77\x6f\x66\x61\x63\x74\x6f\x72"})."\x20"));if ((
$$ref_parameters{"\x74\x77\x6f\x66\x61\x63\x74\x6f\x72"}eq "\x79\x65\x73")){if (
(($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65\x64\x32\x66\x61"}ne "\x31")or (
$$ref_parameters{"\x75\x73\x65\x72\x43\x68\x61\x6e\x67\x65\x64"}==
(0x111f+ 1100-0x156a)))){($options.=(("\x75\x73\x65\x72\x49\x64\x3d".
$$ref_parameters{"\x75\x73\x65\x72"})."\x20"));}if ((($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65\x64\x32\x66\x61"}ne "\x31")or ($$ref_parameters{
"\x6e\x6f\x74\x69\x66\x79\x43\x68\x61\x6e\x67\x65\x64"}==(0x1425+  66-0x1466))))
{($options.=(("\x6e\x6f\x74\x69\x66\x79\x3d".$$ref_parameters{
"\x6e\x6f\x74\x69\x66\x79"})."\x20"));}}main::nxrequire (
"\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x43\x6c\x69\x65\x6e\x74\x44\x61\x65\x6d\x6f\x6e"
);NXNetworkClientDaemon::askForSet2faOptions ($options,(\$error));if (($error eq
 "\x4e\x6f\x20\x64\x65\x76\x69\x63\x65\x73\x20\x70\x61\x69\x72\x65\x64")){
NXMsg::warning (
"\x77\x47\x55\x49\x32\x66\x61\x4e\x6f\x44\x65\x76\x69\x63\x65\x50\x61\x69\x72\x65\x64"
);}elsif (($error ne (""))){NXMsg::error (
"\x65\x43\x4d\x44\x32\x66\x61\x43\x61\x6e\x6e\x6f\x74\x43\x68\x61\x6e\x67\x65\x53\x74\x61\x74\x75\x73"
,$error);NXShell::setExitRequestCommandFinished ();return ((0x15e0+ 1927-0x1d66)
);}return ((0x0fa8+ 4086-0x1f9e));}sub informAboutNetworkInfoUpdate{
main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
(my $machineId=NXNetworkRedis::getMachineId ());
NXRedisSubscription::publishToNXCMSubscribers (((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_NETWORK_UPDATE).
"\x20\x50\x61\x72\x65\x6e\x74\x20\x4e\x65\x74\x77\x6f\x72\x6b\x20\x69\x6e\x66\x6f\x20\x6d\x61\x63\x68\x69\x6e\x65\x49\x64\x3d"
).$machineId));}"\x3f\x3f\x3f";
